        program cylindre

c	versnio de main avec splitting x,y,z du transport/remesh de rho
c	le poussuer/remaille de om et rho sont dissocies

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp1(npm),yp1(npm),zp1(npm),dv1(npm)
        dimension xp2(npm),yp2(npm),zp2(npm)
        dimension omx(npm),omy(npm),omz(npm)
        dimension vx1(npm),vy1(npm),vz1(npm)
        dimension vx2(npm),vy2(npm),vz2(npm)
        dimension strx(npm),stry(npm),strz(npm)
	dimension phip(npm)
c       tableuax supplementaries pour RK
      dimension xp10(npm),yp10(npm),zp10(npm)
      dimension xp20(npm),yp20(npm),zp20(npm)
      dimension om1(npm),om2(npm),om3(npm)
      dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
      dimension vxv1(4,npm),vyv1(4,npm),vzv1(4,npm)
      dimension vxv2(4,npm),vyv2(4,npm),vzv2(4,npm)

      dimension para(4)
      dimension enstrophy(0:10000),energy(0:10000),divergence(0:10000)  

      data (para(i),i=1,4)/0.5,0.5,1.,0./

        character*30 filerho,fileomx,fileomy,fileomz


        pi=3.1415926
        pi2=2.*pi

        OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2
        READ(1,*)
        read(1,*)nit
        READ(1,*)
        read(1,*)anu
        READ(1,*)
        read(1,*)anu_rho
        READ(1,*)
        read(1,*)coef_les
        READ(1,*)
        read(1,*)tstop
        close(1)

	circlim=-1.

        xmin=0.
        ymin=0.
        zmin=0.
        xmax=1
        ymax=xmax
        dx1=xmax/float(nx1)
        dx2=xmax/float(nx2)
        zmax=xmax

        t1=0.14
	    t2=1.4
c        t3=0.784
c        t4=1.13
	t3=1000.
	t4=1000.
        
c	resolution pour rho
c	et initalisation des comptuer utlise pour 
c	avoir des pas de temps distincts en rho et omega

	nx3=128
	dx3=xmax/float(nx3)
	ic=0
 
        dy1=dx1
        dz1=dx1
        ny1=nint(float(nx1)*ymax/xmax)
        nz1=nint(float(nx1)*zmax/xmax)
        ymax=float(ny1)*dy1
        zmax=float(nz1)*dz1
        dy2=dx2
        dz2=dx2
        ny2=nint(float(nx2)*ymax/xmax)
        nz2=nint(float(nx2)*zmax/xmax)

	print*, nx1,ny1,nz1,xmax,ymax,zmax


	call readfield(rhomax,vmax,dvmax)

c       debut des iterations

	time=0.
	tcompt=0.
	istep=0

        do 20 kk=1,nit
	
	print*,'VMAX et DV MX ',vmax,dvmax/dx3
c	delt3=0.0036
c	delt3=0.0144
	delt3=1.
	if (dvmax.ne.0.) delt3=amin1(delt3,0.25*dx3/dvmax)
	print*, ' ITE, TIME, Pas de temps ', kk,time,delt3
	print*, 'CFL1 CFL2 et LCFL ',
     1            vmax*delt3/dx3,vmax*delt3/dx2,dvmax*delt3/dx3
	print*,' Worstcase: LCF=2 x CFL1 = 1/2 CFL2'
c	cfl=0.4
c	delt3=cfl*dx3/2.
c	delt3=0.2*dx3/dvmax

	dt=delt3
	np_bl=3
	nx=nx2
	dx=dx2
        call x_advect(dt,np_bl,npart_rho,ntagx)
        call y_advect(dt,np_bl,ntagy)
        call z_advect(dt,np_bl,ntagz)

	
	call dif_rho(anu_rho,dt)

c	Fin de push / remesh rho /dif rho
	if (kk.eq.nit) then

       open(20,file='rho_bin',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')

        write(20)  (((ug(i,j,k),
     1                i=1,nx2),j=1,ny2),k=1,nz2)

                      open(24,file='rho_asci')
	umax=0.
            WRITE(24,'(A)') "# vtk DataFile Version 3.0"
        WRITE(24,'(A)') "Scalar"
        WRITE(24,'(A)') "ASCII"
        WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
        WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx2," ",nx2," ",nx2
        WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
        WRITE(24,*) "SPACING"," ",dx," ",dx," ",dx
        WRITE(24,*) "POINT_DATA ",nx2*nx2*nx2
        WRITE(24,'(A)') "SCALARS omg float"
        WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
        do k=1,nx2
        do j=1,nx2
        do i=1,nx2
                umax=amax1(umax,abs(ug(i,j,k)))
                write(24,*) ug(i,j,k)
        enddo
        enddo
        enddo
	close(24)
	endif
                print*,'****  time, RHO MAX = ',time,umax

223	continue


	time=time+dt
20	continue


202	continue
	stop
	end

