	program spec


        include 'param_rho.i'
        include 'param.h'

	parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

        parameter(npg2=256)
        parameter(npgb2=npg2/2)

        dimension rhog(npgx,npgy,npgz)
        dimension ug(npg2,npg2,npg2)

	complex cfx,cfy,cfz,cux,cuy,cuz,wk
	common/fft/cfx(1-ngx2:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cux(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz)
      real ijc(1-ngx2:ngx2,1-ngx2:ngx2,1-ngx2:ngx2)
      real nrj(ngx2) 

	complex cvx,wk2
        dimension cvx(0:npgb2,1-npgb2:npgb2,1-npgb2:npgb2)
	dimension wk2(npgb2+1,npg2,npg2)

       OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2

	nx3=256

	ny2=nx2
	nz2=nx2

	nxb=nx2/2
	nyb=ny2/2
	nzb=nz2/2

        nxb2=nx3/2
        nyb2=nx3/2
        nzb2=nx3/2

      open(20,file='rho',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
        read(20)  (((rhog(i,j,k),
     1                i=1,nx2),j=1,ny2),k=1,nz2)
       close(20)

	print*,' Lecture finie '

      call fftw3d(rhog,cux,nx2,ny2,nz2,nxb,nyb,nzb,wk,0)

      do 10 k=1-nzb2,nzb2
         do 10 j=1-nyb2,nyb2
            do 10 i=0,nxb2
      cvx(i,j,k)=cux(i,j,k)
10    continue

      call fftw3d(ug,cvx,nx3,nx3,nx3,nxb2,nyb2,nzb2,wk2,1)

                      open(24,file='half_rho')

            WRITE(24,'(A)') "# vtk DataFile Version 3.0"
        WRITE(24,'(A)') "Scalar"
        WRITE(24,'(A)') "ASCII"
        WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
        WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx3," ",nx3," ",nx3
        WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
        WRITE(24,*) "SPACING"," ",1./nx3," ",1./nx3," ",1./nx3
        WRITE(24,*) "POINT_DATA ",nx3*nx3*nx3
        WRITE(24,'(A)') "SCALARS omg float"
        WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
        do k=1,nx3
        do j=1,nx3
        do i=1,nx3
                write(24,*) amax1(0.00001,ug(i,j,k))
        enddo
        enddo
        enddo
        close(24)


         do k=1-nzb,nzb
         do j=1-nyb,nyb
           cfx(0,j,k)=cux(0,j,k)
         do i=1,nxb
          if (i.le.nxb-1) cfx(-i,j,k)=cux(i,j,k)
          cfx(i,j,k)=cux(i,j,k)
         enddo
         enddo
         enddo
c
	print*,' sort de fft '

        open(1,file='spectre')

	s=0.
        do l=1,nxb2
c
         do k=1-nzb2-2,nzb2+2
         do j=1-nyb2-2,nyb2+2
         do i=1-nxb2-2,nxb2+2
         ijc(i,j,k)=float(i**2+j**2+k**2)
         xmod=sqrt(ijc(i,j,k))
         if ((xmod.lt.l+0.5).and.(xmod.ge.l-0.5)) then
         z=cabs(cfx(i,j,k))**2
         s=s+z
         endif
         enddo
         enddo
         enddo
c
	print*, 'L =',l
        nrj(l)=s
c
        write(1,*)l,nrj(l)/2
        s=0.
        enddo
        close(1)
c

c	filter at half-size
	stop
	end

