        subroutine remesh_tag(ntag,itag,itype,icfl)


        include 'param.i'
        include 'param.h'
		
		dimension itag(*),itype(*),icfl(*)


	dxinv=1./dx
	x0=-1.

	do n=1,ntag,2
		i=itag(n)
		ii=mod(i,nx)+1
		x=xp(i)
		y=xp(ii)
		u1=up(i)
		u2=up(ii)
		if (itype(i).eq.0) then
! case (c) and (d)
c
! 		if (vx(ii)*cfl-icfl(ii).lt.0) then
		ip1 = int((x-x0)*dxinv)
		jp1 = nint((y-x0)*dxinv)
		xx1 = (x - float(ip1)*dx-x0)*dxinv
		yy1 = (y - float(jp1)*dx-x0)*dxinv
		xx0=xx1+1
		xx2=1-xx1
		yy0=yy1+1
		yy2=1-yy1
		ip0=ip1-1
		ip2=ip1+1
		ip3=ip1+2
		ip4=ip1+3
        ip1=mod(ip1+nx,nx) +1
        ip0=mod(ip0+nx,nx) +1
        ip2=mod(ip2+nx,nx) +1
		ip3=mod(ip3+nx,nx) +1
        ip4=mod(ip4+nx,nx) +1
		a0=-xx1*xx2/2.
		a1=xx0*xx2
		b1=yy0*yy2
		b2=yy0*yy1/2.
		ug(ip0)=ug(ip0)+a0*u1
		ug(ip1)=ug(ip1)+a1*u1+(1.+yy1-b1-b2)*u2
		ug(ip2)=ug(ip2)+xx1*u1-yy1*u2
		ug(ip3)=ug(ip3)+(1.-a0-a1-xx1)*u1+b1*u2
		ug(ip4)=ug(ip4)+b2*u2
! 	print*, 'REMESH_TAG ',n,i,ii,ip1,jp1
! 		else
! case (d)
! 		endif
		else
! case (c') and (d')
c
! 		if (vx(i)*cfl-icfl(i).lt.0) then
		ip1 = nint((x-x0)*dxinv)
		jp1 = int((y-x0)*dxinv)
		xx1 = (x - float(ip1)*dx-x0)*dxinv
		yy1 = (y - float(jp1)*dx-x0)*dxinv
		xx2=1-xx1
		yy0=yy1+1
		ip0=ip1-1
		ip2=ip1+1
		ip1=mod(ip1+nx,nx) +1
        ip0=mod(ip0+nx,nx) +1
        ip2=mod(ip2+nx,nx) +1		
		a0=-0.5*xx1*xx2
		b2=0.5*yy0*yy1
		ug(ip0)=ug(ip0)+a0*u1
		ug(ip1)=ug(ip1)+(1.-a0)*u1+(1.-b2)*u2
		ug(ip2)=ug(ip2)+b2*u2
! 	print*, 'REMESH_TAG ',n,i,ii,ip1,jp1

! 		else
! case (d')
! 		endif
		endif
	enddo
	
	
		return
		end
	

