        subroutine remeshy_tag(ntag,itag,itype,icfl,jj,kk,sl)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'
		
	integer itag(*),itype(*),icfl(*)
        dimension sl(*)


	dxinv=1./dx2
	x0=xmin

	do n=1,ntag,2
		i=itag(n)
                ib=mod(i-2+nx,nx)+1
		ii=itag(n+1)
                iib=mod(ii-2+nx,nx)+1
		x=xp(i)
		y=xp(ii)
		u1=up(i)
		u2=up(ii)
		if (itype(i).eq.0) then
! case (c) and (d)
c
! 		if (vx(ii)*cfl-icfl(ii).lt.0) then
		ip1 = int((x-x0)*dxinv)
		jp1 = nint((y-x0)*dxinv)
		xx1 = (x - float(ip1)*dx2-x0)*dxinv
		yy1 = (y - float(jp1)*dx2-x0)*dxinv
		xx0=xx1+1
		xx2=1-xx1
		yy0=yy1+1
		yy2=1-yy1
		ip0=ip1-1
		ip2=ip1+1
		ip3=ip1+2
		ip4=ip1+3
        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
	ip3=mod(ip3+nx2,nx2) +1
        ip4=mod(ip4+nx2,nx2) +1
c       version avec limituers de pente
        a0=0.5*((xx1-0.5)**2)-sl(ib)/8.
        a1=0.75-xx1**2+(sl(i)+sl(ib))/8.
        b1=0.75-yy1**2+(sl(ii)+sl(iib))/8.
        b2=0.5*((yy1+0.5)**2)-sl(ii)/8.
		ug(jj,ip0,kk)=ug(jj,ip0,kk)+a0*u1
		ug(jj,ip1,kk)=ug(jj,ip1,kk)+a1*u1+(1.+yy1-b1-b2)*u2
		ug(jj,ip2,kk)=ug(jj,ip2,kk)+xx1*u1-yy1*u2
		ug(jj,ip3,kk)=ug(jj,ip3,kk)+(1.-a0-a1-xx1)*u1+b1*u2
		ug(jj,ip4,kk)=ug(jj,ip4,kk)+b2*u2
! 	print*, 'REMESH_TAG ',n,i,ii,ip1,jp1
! 		else
! case (d)
! 		endif
		else
! case (c') and (d')
c
! 		if (vx(i)*cfl-icfl(i).lt.0) then
		ip1 = nint((x-x0)*dxinv)
		jp1 = int((y-x0)*dxinv)
		xx1 = (x - float(ip1)*dx2-x0)*dxinv
		yy1 = (y - float(jp1)*dx2-x0)*dxinv
		xx2=1-xx1
		yy0=yy1+1
		ip0=ip1-1
		ip2=ip1+1
		ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1		
c       version avec limituers de pente
        a0=0.5*((xx1-0.5)**2)-sl(ib)/8.
        b2=0.5*((yy1+0.5)**2)-sl(ii)/8.
		ug(jj,ip0,kk)=ug(jj,ip0,kk)+a0*u1
		ug(jj,ip1,kk)=ug(jj,ip1,kk)+(1.-a0)*u1+(1.-b2)*u2
		ug(jj,ip2,kk)=ug(jj,ip2,kk)+b2*u2
! 	print*, 'REMESH_TAG ',n,i,ii,ip1,jp1

! 		else
! case (d')
! 		endif
		endif
	enddo
	
	
		return
		end
	

