        subroutine remeshz_omz(np1,xp1,up1,itype,jj,kk)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	dimension xp1(*),up1(*),itype(*)



! remaillage des particules fluides

	dxinv=1./dx2

	do i=1,nx2
	omg3(jj,kk,i)=0.
	enddo

         x0=xmin

         do n = 1,np1
            g1 = up1(n)
            x = xp1(n)
			
			if (itype(n).eq.0) then
            ip1 = int((x-x0)*dxinv)
		else
            ip1 = nint((x-x0)*dxinv)
		endif
	    ip0 = ip1 - 1
            ip2 = ip1 + 1
            ip3 = ip1 - 2
            ip4 = ip1 + 2



           xx1 = (x - float(ip1)*dx2-x0)*dxinv
           xx0=xx1+1.
           xx2=xx1-1.
           xx3=xx1+2.
           xx4=xx1-2.

        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
        ip3=mod(ip3+nx2,nx2) +1
        ip4=mod(ip4+nx2,nx2) +1
c
c     Lambda4:
c
          a0 = -xx4*xx2*xx1*xx3/6.
          a1 = xx0*xx2*xx3*xx4/4.
          a2 = -xx0*xx1*xx3*xx4/6.
          a3 = xx0*xx1*xx2*xx4/24.
          a4 = xx0*xx1*xx2*xx3/24.

           omg3(jj,kk,ip0) = omg3(jj,kk,ip0) + g1*a0
           omg3(jj,kk,ip1) = omg3(jj,kk,ip1) + g1*a1
           omg3(jj,kk,ip2) = omg3(jj,kk,ip2) + g1*a2
           omg3(jj,kk,ip3) = omg3(jj,kk,ip3) + g1*a3
           omg3(jj,kk,ip4) = omg3(jj,kk,ip4) + g1*a4
		   
	enddo

        RETURN
        END



