        subroutine remeshz_omz_tag(ntag,itag,itype,icfl,jj,kk)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'
		
		integer itag(*),itype(*),icfl(*)

	dxinv=1./dx2

	do n=1,ntag-1,4
! reperage des 4 particules taggees: positions, poids 
		i=itag(n)
		ii=itag(n+1)
		iii=itag(n+2)
		iiii=itag(n+3)
		x1m=xp(i)
		x0=xp(ii)
		x1p=xp(iii)
		x2p=xp(iiii)
		u1m=up(i)
		u0=up(ii)
		u1p=up(iii)
		u2p=up(iiii)
! print*,n,i,x1m,x0,x1p,x2p,u1m,u0,u1p,u2p,itype(i),itype(ii),
c     1  itype(iii),itype(iiii)
c
c    reperage du point de base pour les 4 particules taggees selon le type
                if (itype(i).eq.0) then
			ip0 = int((x0-xmin)*dxinv)
			ip1m = int((x1m-xmin)*dxinv)
			ip1p = nint((x1p-xmin)*dxinv)
			ip2p = nint((x2p-xmin)*dxinv)
		else
                        ip0 = nint((x0-xmin)*dxinv)
                        ip1m = nint((x1m-xmin)*dxinv)
                        ip1p = int((x1p-xmin)*dxinv)
                        ip2p = int((x2p-xmin)*dxinv)
    		endif
		xx0 = (x0 - float(ip0)*dx2-xmin)*dxinv
		xx1m = (x1m - float(ip1m)*dx2-xmin)*dxinv
		xx1p = (x1p - float(ip1p)*dx2-xmin)*dxinv
		xx2p = (x2p - float(ip2p)*dx2-xmin)*dxinv
! print*,xx1m,xx0,xx1p,xx2p
! reperage des points de grille concernes
c de I-3 a I+5 ou I est point de grille a gauche de particule x0
	        ip3m=ip0-3
	        ip2m=ip0-2
	        ip1m=ip0-1
	        ip5p=ip0+5
	        ip4p=ip0+4
	        ip3p=ip0+3
	        ip2p=ip0+2
	        ip1p=ip0+1
	        ip0=mod(ip0+nx,nx) +1
	        ip1p=mod(ip1p+nx,nx) +1
	        ip2p=mod(ip2p+nx,nx) +1
	        ip3p=mod(ip3p+nx,nx) +1
	        ip4p=mod(ip4p+nx,nx) +1
	        ip5p=mod(ip5p+nx,nx) +1
	        ip1m=mod(ip1m+nx,nx) +1
	        ip2m=mod(ip2m+nx,nx) +1
	        ip3m=mod(ip3m+nx,nx) +1
c       cases (c) and (d)
c
                if (itype(i).eq.0) then
	coef1m=(xx1m-2.)*(xx1m-1.)*xx1m*(xx1m+1)/24.
	omg3(jj,kk,ip3m)=omg3(jj,kk,ip3m)+u1m*coef1m
c
	coef1m=-(xx1m-2.)*(xx1m-1.)*xx1m*(xx1m+2)/6.
	coef0=(xx0-2.)*(xx0-1.)*xx0*(xx0+1)/24.
	omg3(jj,kk,ip2m)=omg3(jj,kk,ip2m)+u1m*coef1m+u0*coef0
c
        coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+1.)*(xx1m+2)/4.
        coef0=-(xx0-2.)*(xx0-1.)*xx0*(xx0+2)/6.
        coef1p=(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
	omg3(jj,kk,ip1m)=omg3(jj,kk,ip1m)+u1m*coef1m+u0*coef0+u1p*coef1p
c
        coef1m=-(xx1m-2.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/6.
        coef0=(xx0-2.)*(xx0-1.)*(xx0+1.)*(xx0+2)/4.
        coef1p=-(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+3)/6.
        coef2p=(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
       	omg3(jj,kk,ip0)=omg3(jj,kk,ip0)+
     1               u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef1m=(xx1m-1.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/24.
	coef1m=coef1m-(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+1)/24.
        coef0=-(xx0-2.)*(xx0-0.)*(xx0+1.)*(xx0+2)/6.
        coef0=coef0+(xx0-3.)*(xx0-1.)*(xx0+0.)*(xx0+1)/6.
        coef0=coef0+(xx0-1.)*(xx0-0.)*(xx0+1.)*(xx0+2)/24.
        coef0=coef0-(xx0-2.)*(xx0-1.)*(xx0+0.)*(xx0+1)/24.
        coef1p=(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+1)/24.
        coef1p=coef1p-(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
        coef1p=coef1p-(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+2)/6.
        coef1p=coef1p+(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+3)/6.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+1)/24.
        coef2p=coef2p-(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
	omg3(jj,kk,ip1p)=omg3(jj,kk,ip1p)+
     1                 u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
	coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+1)/24.
        coef0=-(xx0-3.)*(xx0-1.)*(xx0+0.)*(xx0+1)/6.
        coef1p=(xx1p-2.)*(xx1p-1.)*(xx1p+1.)*(xx1p+2)/4.
        coef2p=-(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+2)/6.
	omg3(jj,kk,ip2p)=omg3(jj,kk,ip2p)+
     1                 u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef0=(xx0-2.)*(xx0-1.)*(xx0+0.)*(xx0+1)/24.
        coef1p=-(xx1p-2.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/6.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+1.)*(xx2p+2)/4.
	omg3(jj,kk,ip3p)=omg3(jj,kk,ip3p)+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef1p=(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
        coef2p=-(xx2p-2.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/6.
	omg3(jj,kk,ip4p)=omg3(jj,kk,ip4p)+u1p*coef1p+u2p*coef2p
! 
        coef2p=(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
	omg3(jj,kk,ip5p)=omg3(jj,kk,ip5p)+u2p*coef2p
c
! 	print*, 'REMESH_TAG ',n,i,ii,ip1,jp1
c
! case (c') and (d')
		else
c
        coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+1)/24.
        omg3(jj,kk,ip3m)=omg3(jj,kk,ip3m)+u1m*coef1m
c
        coef1m=-(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+2)/6.
        coef0=(xx0-2.)*(xx0-1.)*xx0*(xx0+1)/24.
        omg3(jj,kk,ip2m)=omg3(jj,kk,ip2m)+u1m*coef1m+u0*coef0
c
        coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+1.)*(xx1m+2)/4.
        coef0=-(xx0-2.)*(xx0-1.)*(xx0+0.)*(xx0+2)/6.
        coef1p=(xx1p-3.)*(xx1p-2.)*(xx1p-1.)*(xx1p+0)/24.
        omg3(jj,kk,ip1m)=omg3(jj,kk,ip1m)+u1m*coef1m+u0*coef0+u1p*coef1p
c
        coef1m=-(xx1m-2.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/6.
        coef1m=coef1m+(xx1m-1.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/24.
        coef0=(xx0-2.)*(xx0-1.)*(xx0+1.)*(xx0+2)/4.
        coef0=coef0-(xx0-2.)*(xx0-0.)*(xx0+1.)*(xx0+2)/6.
        coef0=coef0+(xx0-1.)*(xx0-0.)*(xx0+1.)*(xx0+2)/24.
        coef0=coef0-(xx0-0.)*(xx0+1.)*(xx0+2.)*(xx0+3)/24.
        coef1p=(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+1)/24.
        coef1p=coef1p-(xx1p-3.)*(xx1p-2.)*(xx1p-1.)*(xx1p+0)/24.
        coef1p=coef1p-(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+2)/6.
        coef1p=coef1p+(xx1p-2.)*(xx1p-1.)*(xx1p+1.)*(xx1p+2)/4.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+1)/24.
        coef2p=coef2p-(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+2)/6.
        omg3(jj,kk,ip0)=omg3(jj,kk,ip0)+
     1                u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef0=(xx0-0.)*(xx0+1.)*(xx0+2.)*(xx0+3)/24.
        coef1p=-(xx1p-2.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/6.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+1.)*(xx2p+2)/4.
        omg3(jj,kk,ip1p)=omg3(jj,kk,ip1p)+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef1p=(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
        coef2p=-(xx2p-2.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/6.
        omg3(jj,kk,ip2p)=omg3(jj,kk,ip2p)+u1p*coef1p+u2p*coef2p
c
        coef2p=(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
        omg3(jj,kk,ip3p)=omg3(jj,kk,ip3p)+u2p*coef2p

		endif
	enddo
	
		return
		end
	

