        subroutine stension(tau,ic)

        include 'param.i'
        include 'param.h'
        include 'arrays.h'


	dimension gradrhox(npg,npg,npg),anormx(npg,npg,npg)
	dimension gradrhoy(npg,npg,npg),anormy(npg,npg,npg)
	dimension gradrhoz(npg,npg,npg),anormz(npg,npg,npg)

        parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

        complex cfx,cfy,cfz,cux,cuy,cuz,wk
        common/fft/cfx(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cux(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz)


        pi=3.1415926
        spi=sqrt(pi)
        phibar=0.5

	taudxinv=tau/(float(ic)*(2.*dx)**2)
        al=0.

	nx1=nx
	ny1=nx
	nz1=nx


c       cas ou on utilise grd rho comme level set
        eps=2.*float(ic)*dx
        eps2=eps**2

! calcul de gradrho et normale

        do i=1,nx
        it=mod(i+ic+nx-1,nx)+1
        ib=mod(i-ic+nx-1,nx)+1
        do j=1,nx
        jt=mod(j+ic+nx-1,nx)+1
        jb=mod(j-ic+nx-1,nx)+1
        do k=1,nx
        kt=mod(k+ic+nx-1,nx)+1
        kb=mod(k-ic+nx-1,nx)+1
        gradrhoz(i,j,k)=ug(i,j,kt)-ug(i,j,kb)
        gradrhoy(i,j,k)=ug(i,jt,k)-ug(i,jb,k)
        gradrhox(i,j,k)=ug(it,j,k)-ug(ib,j,k)
        gradrho=sqrt(gradrhox(i,j,k)**2
     &             +gradrhoy(i,j,k)**2+gradrhoz(i,j,k)**2)
	anormx(i,j,k)=0.
	anormy(i,j,k)=0.
	anormz(i,j,k)=0.
	if ((abs(ug(i,j,k)-0.5).lt.0.4).or.(gradrho.ge.0.00001)) then
	anormx(i,j,k)=gradrhox(i,j,k)/gradrho
	anormy(i,j,k)=gradrhoy(i,j,k)/gradrho
	anormz(i,j,k)=gradrhoz(i,j,k)/gradrho
	endif
c        al=al+gradrho
        enddo
        enddo
        enddo

! calcul de courbure x gradrho
	
        do i=1,nx
        it=mod(i+1+nx-1,nx)+1
        ib=mod(i-1+nx-1,nx)+1
        do j=1,nx
        jt=mod(j+1+nx-1,nx)+1
        jb=mod(j-1+nx-1,nx)+1
        do k=1,nx
        kt=mod(k+1+nx-1,nx)+1
        kb=mod(k-1+nx-1,nx)+1
	acurv=anormx(it,j,k)-anormx(ib,j,k)
	acurv=acurv+anormy(i,jt,k)-anormy(i,jb,k)
	acurv=acurv+anormz(i,j,kt)-anormz(i,j,kb)
	gradrhox(i,j,k)=gradrhox(i,j,k)*acurv*taudxinv
	gradrhoy(i,j,k)=gradrhoy(i,j,k)*acurv*taudxinv
	gradrhoz(i,j,k)=gradrhoz(i,j,k)*acurv*taudxinv
	enddo
	enddo
	enddo

! curl de tension superificielle
! en fourier

        nxb=nx1/2
        nyb=ny1/2
        nzb=nz1/2

       call fftw3d(gradrhox,cfx,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)
       call fftw3d(gradrhoy,cfy,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)
       call fftw3d(gradrhoz,cfz,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)

        ai=2.*pi/(xmax-xmin)
        aj=2.*pi/(ymax-ymin)
        ak=2.*pi/(zmax-zmin)

        ai2=ai**2
        aj2=aj**2
        ak2=ak**2

      do 10 k=1-nzb,nzb
         rk=float(k)*ak
         do 10 j=1-nyb,nyb
            rj=float(j)*aj
            do 10 i=0,nxb
               ri=float(i)*ai
      cux(i,j,k)=cmplx(0.0,1.0)*(-rj*cfz(i,j,k)+rk*cfy(i,j,k))
      cuy(i,j,k)=cmplx(0.0,1.0)*(-rk*cfx(i,j,k)+ri*cfz(i,j,k))
      cuz(i,j,k)=cmplx(0.0,1.0)*(-ri*cfy(i,j,k)+rj*cfx(i,j,k))
10    continue


      call fftw3d(strg1,cux,nx1,ny1,nz1,nxb,nyb,nzb,wk,1)
      call fftw3d(strg2,cuy,nx1,ny1,nz1,nxb,nyb,nzb,wk,1)
      call fftw3d(strg3,cuz,nx1,ny1,nz1,nxb,nyb,nzb,wk,1)


        return
        end

