        subroutine stension(tau,ic)

        include 'param.i'
        include 'param.h'
        include 'arrays.h'


	dimension gradrhox(npg,npg,npg),anormx(npg,npg,npg)
	dimension gradrhoy(npg,npg,npg),anormy(npg,npg,npg)
	dimension gradrhoz(npg,npg,npg),anormz(npg,npg,npg)
	dimension curv(npg,npg,npg)



        pi=3.1415926
        spi=sqrt(pi)
        phibar=0.5

	taudxinv=tau/(float(ic)*(2.*dx)**3)
        al=0.

! cas ou on ne passe pas par stretch d'abor:

	goto 1111
	do k=1,nx
	do j=1,nx
	do i=1,nx
	strg1(i,j,k)=0.
	strg2(i,j,k)=0.
	strg3(i,j,k)=0.
	enddo
	enddo
	enddo
1111	continue

c       cas ou on utilise grd rho comme level set
        eps=2.*float(ic)*dx
        eps2=eps**2

! calcul de gradrho et normale

        do i=1,nx
        it=mod(i+ic+nx-1,nx)+1
        ib=mod(i-ic+nx-1,nx)+1
        do j=1,nx
        jt=mod(j+ic+nx-1,nx)+1
        jb=mod(j-ic+nx-1,nx)+1
        do k=1,nx
        kt=mod(k+ic+nx-1,nx)+1
        kb=mod(k-ic+nx-1,nx)+1
        gradrhoz(i,j,k)=ug(i,j,kt)-ug(i,j,kb)
        gradrhoy(i,j,k)=ug(i,jt,k)-ug(i,jb,k)
        gradrhox(i,j,k)=ug(it,j,k)-ug(ib,j,k)
        gradrho=sqrt(gradrhox(i,j,k)**2
     &             +gradrhoy(i,j,k)**2+gradrhoz(i,j,k)**2)
	anormx(i,j,k)=0.
	anormy(i,j,k)=0.
	anormz(i,j,k)=0.
	if ((abs(ug(i,j,k)-0.5).lt.0.1).or.(gradrho.ge.0.00001)) then
	anormx(i,j,k)=gradrhox(i,j,k)/gradrho
	anormy(i,j,k)=gradrhoy(i,j,k)/gradrho
	anormz(i,j,k)=gradrhoz(i,j,k)/gradrho
	endif
c        al=al+gradrho
        enddo
        enddo
        enddo

! calcul de courbure x gradrho
	
        do i=1,nx
        it=mod(i+1+nx-1,nx)+1
        ib=mod(i-1+nx-1,nx)+1
        do j=1,nx
        jt=mod(j+1+nx-1,nx)+1
        jb=mod(j-1+nx-1,nx)+1
        do k=1,nx
        kt=mod(k+1+nx-1,nx)+1
        kb=mod(k-1+nx-1,nx)+1
	acurv=anormx(it,j,k)-anormx(ib,j,k)
	acurv=acurv+anormy(i,jt,k)-anormy(i,jb,k)
	acurv=acurv+anormz(i,j,kt)-anormz(i,j,kb)
	gradrhox(i,j,k)=gradrhox(i,j,k)*acurv
	gradrhoy(i,j,k)=gradrhoy(i,j,k)*acurv
	gradrhoz(i,j,k)=gradrhoz(i,j,k)*acurv
! curv(i,j,k)=acurv
	enddo
	enddo
	enddo

! curl de tension superificielle

	strmax=0.
        do i=1,nx
        it=mod(i+1+nx-1,nx)+1
        ib=mod(i-1+nx-1,nx)+1
        do j=1,nx
        jt=mod(j+1+nx-1,nx)+1
        jb=mod(j-1+nx-1,nx)+1
        do k=1,nx
        kt=mod(k+1+nx-1,nx)+1
        kb=mod(k-1+nx-1,nx)+1
	strg1(i,j,k)=strg1(i,j,k)-
     &               (gradrhoz(i,jt,k)-gradrhoz(i,jb,k))*taudxinv
     &              +(gradrhoy(i,j,kt)-gradrhoy(i,j,kb))*taudxinv
	strg2(i,j,k)=strg2(i,j,k)-
     &               (gradrhox(i,j,kt)-gradrhox(i,j,kb))*taudxinv
     &              +(gradrhoz(it,j,k)-gradrhoz(ib,j,k))*taudxinv
	strg3(i,j,k)=strg3(i,j,k)-
     &               (gradrhoy(it,j,k)-gradrhoy(ib,j,k))*taudxinv
     &              +(gradrhox(i,jt,k)-gradrhox(i,jb,k))*taudxinv
	strmax=amax1(strmax,abs(strg1(i,j,k)))
	strmax=amax1(strmax,abs(strg2(i,j,k)))
	strmax=amax1(strmax,abs(strg3(i,j,k)))
	enddo
	enddo
	enddo

	print*, 'STRMAX ',strmax
112     continue

c        al=al*dx*dx*dx/eps

        return
        end

