	    subroutine tag_particles(npart,npart_aux,ntag,np_bl,
     1    icfl,itype,itype_aux,itag,
     1    xp_aux,up_aux,vx_aux)

        include 'param.i'
        include 'param.h'
 
         common/remesh/xp(npg),xp1(npg),up(npg),vx(npg)

        integer icfl(*),itype(*),itype_aux(*),itag(*)
        dimension xp_aux(*),up_aux(*),vx_aux(*)

        integer ntype(npg),ncfl(npg),npart_bl(npg),i_nbl(npg)
        dimension amin_lambda(npg)

        
c    ntype(nbl) : type de bloc (1=centre ou 0=left) pour choix de la formule
c            remaillage
c    itype(npart) : idem pour les particules de ces blocks
c    ncfl(nbl)=cfl-nint ou cfl-int selon le type
c    icfl(npart) : idem pour particules de cs blocks
c    xp_aux(npart_aux): particles inside the blocks, for plain remeshing
c    itype_aux(npart_aux) : type de block pour ces particules
c    ntag: number of tagged particles, for special remeshing
c    itag(ntag): pointer for tagged particles
c    i_nbl(nbl) indice de la derniere particule du bloc nbl

      x0=xmin
    
      m=np_bl+1
      nblock=nx/(m)
      dx_bl=float(m)*dx
      dx_bl_inv=1./dx_bl
    
c        on range les partucles par block
c        et on calcule lambda moyen pour chaque block

      do nbl=1,nblock
        amin_lambda(nbl)=111.
        npart_bl(nbl)=0
        i_nbl(nbl)=0
      enddo
    
      do i=1,npart
        nbl=1+int((xp(i)-x0+0.0001)*dx_bl_inv)
        amin_lambda(nbl)=amin1(amin_lambda(nbl),vx(i)*cfl)
        npart_bl(nbl)=npart_bl(nbl)+1
        i_nbl(nbl)=i
      enddo
    
c    on ajoute la particule a droite du bloc (si elle existe) pour calculer
c    le amin_lambda, pour eviter pbms a l'interface entre blocs de meme type
c   (a corriger: pour l'instant je ne regarde pas le dernier bloc avec xp(1)

      do nbl=1,nblock-1
         if (i_nbl(nbl).ne.0) then
            ii=i_nbl(nbl)
            if ((ii.lt.npart).and.(xp(ii+1).lt.xp(ii)+1.5*dx)) then
            amin_lambda(nbl)=amin1(amin_lambda(nbl),vx(ii+1)*cfl)
            endif
         endif
! print*, 'TYPES ',nbl,ii,amin_lambda(nbl)
      enddo
    
c     le dernier bloc (a la main ..)

      nbl=nblock
      if (i_nbl(nbl).ne.0) then
            ii=i_nbl(nbl)
         if ((xp(ii).ge.xmax-1.5*dx).and.(xp(ii+1).lt.xmin+0.5*dx)) then
         amin_lambda(nbl)=amin1(amin_lambda(nbl),vx(ii+1)*cfl)
         endif
      endif

    
c        et on en deduit type de block (1=centre vs 0=left) et l'indice du bloc
            

      do nbl=1,nblock
         if (amin_lambda(nbl).lt.nint(amin_lambda(nbl))) then
            ntype(nbl)=1
            ncfl(nbl)=nint(amin_lambda(nbl))
         else
            ntype(nbl)=0
            ncfl(nbl)=int(amin_lambda(nbl))
            if (amin_lambda(nbl).lt.0) ncfl(nbl)=int(amin_lambda(nbl))-1
         endif

c        print*,'nbl et type',nbl, ntype(nbl),amin_lambda(nbl)
      enddo
c
c        on affecte le type et l'indice cfl du bloc sur ses particules 


      do i=1,npart
         nbl=1+int((xp(i)-x0+0.0001)*dx_bl_inv)
         itype(i)=ntype(nbl)
         icfl(i)=ncfl(nbl)
c        print*,'nbl et type',nbl,i, itype(i),icfl(i)
      enddo
    
    
c    on tagge les particules entre les blocs successifs non vides qui: dfdsfdfdfsdsdffsdfsdfsdfsdfsdfsdf
c    sont de type et indice cfl differents 
c    (cases b,c,b',c' du papier)

      ntag=0
      npart_aux=0
      j=1
      jc=0
      do i=1,npart
         j=j+jc
         if (j.gt.npart) go to 111
        j1=j
        jj=j+1
        jjj=j+2
         if ((jjj.le.npart).and.(icfl(jj).ne.icfl(jjj))
     1   .and.(itype(jj).ne.itype(jjj))
     1   .and.(xp(jjj).le.xmin+amod(xp(jj)+1.5*dx-xmin,xmax-xmin))) then
            ntag=ntag+1
            itag(ntag)=j1
            ntag=ntag+1
            itag(ntag)=jj
            ntag=ntag+1
            itag(ntag)=jjj
            ntag=ntag+1
            itag(ntag)=j+3
            jc=4
! cprint*,'tags',ntag,j1,jj,jjj,j+3
! print*,' Blocs', itype(jj),icfl(jj),itype(jjj),icfl(jjj)
! print*,xp(jj),xp(jjj)
         else
            npart_aux=npart_aux+1
            xp_aux(npart_aux)=xp(j1)
            up_aux(npart_aux)=up(j1)
            vx_aux(npart_aux)=vx(j1)
            itype_aux(npart_aux)=itype(j1)
            jc=1
         endif
      enddo

111    continue
        if (npart_aux+ntag.ne.npart) print*,'ATT**',j,npart_aux,ntag,jc

    
       return
       end
