	subroutine velox_bar(delt)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension aux3(npgx,npgy,npgz),
     1             aux1(npgx,npgy,npgz),aux2(npgx,npgy,npgz)

	parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

	complex cfx,cfy,cfz,cux,cuy,cuz,wk
	common/fft/cfx(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cux(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz)


        pi=3.1415926

! calcu de grad rho x g

        do k=1,nz2
        kt=mod(k+nz1,nz1)+1
        kb=mod(k-2+nz1,nz1)+1
        ktt=mod(k+1+nz1,nz1)+1
        kbb=mod(k-3+nz1,nz1)+1
cc
        do j=1,ny2
        jt=mod(j+ny1,ny1)+1
        jb=mod(j-2+ny1,ny1)+1
        jtt=mod(j+1+ny1,ny1)+1
        jbb=mod(j-3+ny1,ny1)+1
cc
        do i=1,nx2
        it=mod(i+nx1,nx1)+1
        ib=mod(i-2+nx1,nx1)+1
        itt=mod(i+1+nx1,nx1)+1
        ibb=mod(i-3+nx1,nx1)+1

        aux=ug(i,j,ktt)+8*(ug(i,j,kb)-ug(i,j,kt))-ug(i,j,kbb)
	cfy(i,j,k)=-aux*drho*delt/(12.*dx2)
        aux=ug(i,jtt,k)+8*(ug(i,jb,k)-ug(i,jt,k))-ug(i,jbb,k)
	cfz(i,j,k)=+aux*drho*delt/(12.*dx2)

	enddo
	enddo
	enddo

! calucl de fonction courants 3d

	nxb=nx2/2
	nyb=ny2/2
	nzb=nz2/2

c      call fftw3d(omg1,cfx,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)
      call fftw3d(omg2,cfy,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)
      call fftw3d(omg3,cfz,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)

c 	coeff de normalisation pour laplacien en spectral

	ai=2.*pi/(xmax-xmin)	
	aj=2.*pi/(ymax-ymin)	
	ak=2.*pi/(zmax-zmin)	
	
	ai2=ai**2
	aj2=aj**2
	ak2=ak**2

      do 10 k=1-nzb,nzb
         rk=float(k)*ak
         do 10 j=1-nyb,nyb
            rj=float(j)*aj
            do 10 i=0,nxb
               ri=float(i)*ai
	       r2=ri**2+rj**2+rk**2
	cux(i,j,k)=cmplx(0.0,0.0)
	cuy(i,j,k)=cmplx(0.0,0.0) 
	cuz(i,j,k)=cmplx(0.0,0.0) 
	if (r2.ne.0.) then
c
      cux(i,j,k)=cmplx(0.0,1.0)*(-rj*cfz(i,j,k)+rk*cfy(i,j,k))/r2
c      cuy(i,j,k)=cmplx(0.0,1.0)*(-rk*cfx(i,j,k)+ri*cfz(i,j,k))/r2
      cuy(i,j,k)=cmplx(0.0,1.0)*(ri*cfz(i,j,k))/r2
c      cuz(i,j,k)=cmplx(0.0,1.0)*(-ri*cfy(i,j,k)+rj*cfx(i,j,k))/r2
      cuz(i,j,k)=cmplx(0.0,1.0)*(-ri*cfy(i,j,k))/r2
        endif
10    continue   

      call fftw3d(aux1,cux,nx2,ny2,nz2,nxb,nyb,nzb,wk,1)
      call fftw3d(aux2,cuy,nx2,ny2,nz2,nxb,nyb,nzb,wk,1)
      call fftw3d(aux3,cuz,nx2,ny2,nz2,nxb,nyb,nzb,wk,1)

	vxmax=0.
	vymax=0.
	vzmax=0.
        do k=1,nz1
        do j=1,ny1
        do i=1,nx1
        vxg(i,j,k)=-aux1(i,j,k)
        vyg(i,j,k)=-aux2(i,j,k)
        vzg(i,j,k)=-aux3(i,j,k)
	vxmax=amax1(vxmax,abs(vxg(i,j,k)))
	vymax=amax1(vymax,abs(vyg(i,j,k)))
	vzmax=amax1(vzmax,abs(vzg(i,j,k)))
        enddo
        enddo
        enddo
	print*,' VXMAX sur grille ',vxmax,vymax,vzmax
	vmax=amax1(vxmax,vymax)
	vmax=amax1(vmax,vzmax)

	return
	end

