	subroutine veloxaux(vmax,dvmax)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        parameter(npg2=32)
        parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

	dimension aux1(npg2,npg2,npg2),aux2(npg2,npg2,npg2)
	dimension aux3(npg2,npg2,npg2)

        parameter(npgb2=npg2/2)

       complex cfx,cfy,cfz,cux,cuy,cuz,wk
        common/fft/cfx(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cux(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz)

        complex cvx,cvy,cvz,wk2
        dimension cvx(0:npgb2,1-npgb2:npgb2,1-npgb2:npgb2),
     1             cvy(0:npgb2,1-npgb2:npgb2,1-npgb2:npgb2),
     1             cvz(0:npgb2,1-npgb2:npgb2,1-npgb2:npgb2),
     1             wk2(npgb2+1,npg2,npg2)

        pi=3.1415926

        nxb2=nx3/2
        nyb2=nx3/2
        nzb2=nx3/2

      do 10 k=1-nzb2,nzb2
         do 10 j=1-nyb2,nyb2
            do 10 i=0,nxb2
      cvx(i,j,k)=cux(i,j,k)
      cvy(i,j,k)=cuy(i,j,k)
      cvz(i,j,k)=cuz(i,j,k)
10    continue


      call fftw3d(aux3,cvz,nx3,nx3,nx3,nxb2,nyb2,nzb2,wk2,1)
      call fftw3d(aux2,cvy,nx3,nx3,nx3,nxb2,nyb2,nzb2,wk2,1)
      call fftw3d(aux1,cvx,nx3,nx3,nx3,nxb2,nyb2,nzb2,wk2,1)

! ecriture fhciers grille  NX2

	umax1=0.
	umax2=0.
	umax3=0.
	dvmax=0.
        do k=1,nx3
        do j=1,nx3
        do i=1,nx3
        psi1(i,j,k)=-aux1(i,j,k)
	umax1=amax1(umax1,abs(psi1(i,j,k)))
        psi2(i,j,k)=-aux2(i,j,k)
	umax2=amax1(umax2,abs(psi2(i,j,k)))
        psi3(i,j,k)=-aux3(i,j,k)
	umax3=amax1(umax3,abs(psi3(i,j,k)))
        enddo
        enddo
        enddo

        do k=1,nx3
        kt=mod(k,nx3)+1
        do j=1,nx3
        jt=mod(j,nx3)+1
        do i=1,nx3
        it=mod(i,nx3)+1
        dvmax=amax1(dvmax,abs(psi1(it,j,k)-psi1(i,j,k)))
        dvmax=amax1(dvmax,abs(psi2(i,jt,k)-psi2(i,j,k)))
        dvmax=amax1(dvmax,abs(psi3(i,j,kt)-psi3(i,j,k)))
        enddo
        enddo
        enddo


	print*,'umax', umax1,umax2,umax3
	vmax=amax1(umax1,umax2,umax3)

	goto 111

      open(20,file='datavelx',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
        write(20)  ((((psi1(i,j,k)),
     1                i=1,nx3),j=1,nx3),k=1,nx3)
      open(21,file='datavely',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
        write(21)  ((((psi2(i,j,k)),
     1                i=1,nx3),j=1,nx3),k=1,nx3)
      open(22,file='datavelz',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
        write(22)  ((((psi3(i,j,k)),
     1                i=1,nx3),j=1,nx3),k=1,nx3)
        close(20)
        close(21)
        close(22)

111	continue



	return
	end
