	subroutine veloxaux(vmax,dvmax)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'


        pi=3.1415926

	dx3=2.*(xmax-xmin)/float(nx3)


	umax1=0.
	umax2=0.
	umax3=0.
	dvmax=0.
        do k=1,nx3
        kt=mod(k,nx3)+1
	pi2z=xmin+float(k-1)*dx3
	piz=0.5*pi2z
        do j=1,nx3
        jt=mod(j,nx3)+1
	pi2y=xmin+float(j-1)*dx3
	piy=0.5*pi2y
        do i=1,nx3
        it=mod(i,nx3)+1
	pi2x=xmin+float(i-1)*dx3
	pix=0.5*pi2x
	psi1(i,j,k)=2.*sin(pix)*sin(pix)*sin(pi2y)*sin(pi2z)
	umax1=amax1(umax1,abs(psi1(i,j,k)))
	psi2(i,j,k)=-sin(pi2x)*sin(piy)*sin(piy)*sin(pi2z)
	umax2=amax1(umax2,abs(psi2(i,j,k)))
	psi3(i,j,k)=-sin(pi2x)*sin(piz)*sin(piz)*sin(pi2y)
	umax3=amax1(umax3,abs(psi3(i,j,k)))
	enddo
	enddo
	enddo

        do k=1,nx3
        kt=mod(k,nx3)+1
        do j=1,nx3
        jt=mod(j,nx3)+1
        do i=1,nx3
        it=mod(i,nx3)+1
        dvmax=amax1(dvmax,abs(psi1(it,j,k)-psi1(i,j,k)))
        dvmax=amax1(dvmax,abs(psi2(i,jt,k)-psi2(i,j,k)))
        dvmax=amax1(dvmax,abs(psi3(i,j,kt)-psi3(i,j,k)))
        enddo
        enddo
        enddo

	print*,'umax', umax1,umax2,umax3
	vmax=amax1(umax1,umax2,umax3)

	return
	end
