	subroutine y_advect_omy(dt,np_bl,ntag_total)
	
        include 'param.i'
        include 'param.h'
        include 'arrays.h'
        
		integer icfl(npg),itype(npg),itype_aux(npg),itag(npg)
		dimension xp_aux(npg),up_aux(npg),vx_aux(npg)

! cfl=dt/dx utilisse pour calculs de blocs et correction
	cfl=dt/dx

        npart=0
        ntag_total=0

	m=np_bl+1
	      		
! on balaie le lignes verticales

	print*,'circlim =',circlim
	do k=1,nx
		zz=xmin+float(k-1)*dx
	do i=1,nx
		yy=xmin+float(i-1)*dx
        np=0
        jj=3
        ic=0
                do j=3,nx+2
        jj=jj+ic
        if (jj.gt.nx+2) go to 111
        j1=mod(jj-1,nx)+1
        j2=mod(jj,nx)+1
        j3=mod(jj+1,nx)+1
        j4=mod(jj+2,nx)+1
        if ((mod(j1,m).eq.m-1).and.
     1      (abs(omg2(i,j1,k))+abs(omg2(i,j2,k))+abs(omg2(i,j3,k))
     1   +abs(omg2(i,j4,k)).ge.circlim)) then
        np=np+1
        up(np)=omg2(i,j1,k)
        xp(np)=xmin+float(j1-1)*dx
        np=np+1
        up(np)=omg2(i,j2,k)
        xp(np)=xmin+float(j2-1)*dx
        np=np+1
        up(np)=omg2(i,j3,k)
        xp(np)=xmin+float(j3-1)*dx
        np=np+1
        up(np)=omg2(i,j4,k)
        xp(np)=xmin+float(j4-1)*dx
        ic=4
        elseif ((abs(omg2(i,j1,k)).ge.circlim)) then
        np=np+1
        up(np)=omg2(i,j1,k)
        xp(np)=xmin+float(j1-1)*dx
        ic=1
        else
        ic=1
        endif
		enddo
111     continue

!  tag, push and remesh sur la ligne
		if (np.ne.0) then

! evaluation des vitesse pour RK2

                call velox_y(np,i,k)
                do n=1,np
                xp0(n)=xp(n)
                xp(n)=xp(n)+0.5*dt*vx(n)
                if (xp(n).gt.xmax) xp(n)=xp(n)-xmax+xmin
                if (xp(n).lt.xmin) xp(n)=xp(n)+xmax-xmin
                enddo
                call velox_y(np,i,k)

		call tag_particles(np,np_aux,ntag,np_bl,
	1   icfl,itype,itype_aux,itag,
	1	xp_aux,up_aux,vx_aux)

	
		if (ntag.ne.0) then
		do n=1,ntag
			ii=itag(n)
			xp(ii)=xp0(ii)+dt*vx(ii)
			if (xp(ii).gt.xmax) xp(ii)=xp(ii)-xmax+xmin
                        if (xp(ii).lt.xmin) xp(ii)=xp(ii)+xmax-xmin
		enddo
		endif
	
		do n=1,np_aux
		xp_aux(n)=xp_aux(n)+dt*vx_aux(n)
	    if (xp_aux(n).gt.xmax) xp_aux(n)=xp_aux(n)-xmax+xmin
            if (xp_aux(n).lt.xmin) xp_aux(n)=xp_aux(n)+xmax-xmin
		enddo
		ir=i
		kr=k
		call remeshy_omy(np_aux,xp_aux,up_aux,itype_aux,ir,kr)
		if (ntag.ne.0) 
     1             call remeshy_omy_tag(ntag,itag,itype,icfl,ir,kr)
	
! fin de ligne i :

		endif
        npart=npart+np
        ntag_total=ntag_total+ntag
	if (ntag_total.lt.0) print*, 'BIZZ ',ntag,i,k
	enddo
	enddo

        print*, ' NTAG apres y advect ', ntag_total

	return
	end
