	subroutine diag(ener,enstro,div,omax,rhomax,width,VOL1,VOL2)

! calcul sur une grille mxmxm de (a,b)**3 du 
! div w, enstro et energy

        include 'param.i'
        include 'param.h'
        include 'arrays.h' 

	dimension umean(npgy)


	
	eps3=dx1**3
	vol=eps3

        dxinv2=0.5/dx1
        dyinv2=0.5/dx1
        dzinv2=0.5/dx1 

	omax=0.
	rhomax=0.
	div=0.
	domax=0.
	ener=0.
        enstro=0.
	dudymax=0.
        do 10 k=1,nz1
        kt=mod(k,nz1)+1
        kb=mod(k-2+nz1,nz1)+1    
        do 10 j=1,ny1
        jt=mod(j,ny1)+1
        jb=mod(j-2+ny1,ny1)+1
        do 10 i=1,nx1
        it=mod(i,nx1)+1
        ib=mod(i-2+nx1,nx1)+1
	aux1=omg1(it,j,k)-omg1(ib,j,k)
	aux2=omg2(i,jt,k)-omg2(i,jb,k)
	aux3=(omg3(i,j,kt)-omg3(i,j,kb))
        psi1(i,j,k)=(aux1*dxinv2+aux2*dyinv2+aux3*dzinv2)
	div=div+((aux1*dxinv2+aux2*dyinv2+aux3*dzinv2)**2)*eps3
	domax=domax+((abs(aux1*dxinv2)+abs(aux2*dyinv2)+
     1           abs(aux3*dzinv2))**2)*eps3
        enerx=vxg(i,j,k)*vxg(i,j,k)
        enery=vyg(i,j,k)*vyg(i,j,k)
        enerz=vzg(i,j,k)*vzg(i,j,k)
        strengthx=omg1(i,j,k)*omg1(i,j,k)
        strengthy=omg2(i,j,k)*omg2(i,j,k)
        strengthz=omg3(i,j,k)*omg3(i,j,k)
        omax=amax1(omax,sqrt(strengthx+strengthy+strengthz))
	rhomax=amax1(rhomax,ug(i,j,k))
        enstro=enstro+(strengthx+strengthy+strengthz)*vol
        ener=ener+(enerx+enery+enerz)*vol  
10	continue

! goto 111

	do j=1,ny1
	umean(j)=0.
	do i=1,nx1
	do k=1,nz1
	umean(j)=umean(j)+dx1*dx1*vxg(i,j,k)
	enddo
	enddo
	enddo

	dudymax=0.
	do j=2,ny1-1
	dudymax=amax1(dudymax,umean(j+1)-umean(j-1))
	enddo

	width=0.
	if (dudymax.ne.0.) width=2.*dx1/dudymax
	if (domax.ne.0) div=div/domax

111	continue


	VOL1=0.
	VOL2=0.
	VOL3=0.
	do k=1,nx2
	do j=1,nx2
	do i=1,nx2
	if (ug(i,j,k).ge.0.5) VOL1=VOL1+dx2*dx2*dx2
	if (ug(i,j,k).ge.0.75) VOL2=VOL2+dx2*dx2*dx2
	enddo
	enddo
	enddo

	return
	end
