	subroutine jet(npart,xp1,yp1,zp1,
     1                 omx,omy,omz,dv1)



        include 'param.i'
        include 'param.h'
        include 'arrays.h'

      dimension xp1(*),yp1(*),zp1(*),dv1(*)
      dimension omx(*),omy(*),omz(*)

	pi=3.1415926
	pi2=2.*pi
	circ=0.
	x0=0.
	y0=0.
	z0=0.
! momentum thickness
	width=0.01
! noise level for the flow
	ampl=0.05
! ampl=0.0
! apltude of wave for vx
	ampl3=0.3
! noise level for the scalar
	ampl2=0.05
	ampl2=0.

        open(20,file='random',form='unformatted',
     1       status='unknown')

        read(20)  (((strg1(i,j,k),strg2(i,j,k),strg3(i,j,k),
     1                i=1,nx1),j=1,ny1),k=1,nz1)


        do i=1,nx1
        do j=1,ny1
        do k=1,nz1
	yy=abs(float(j-1)*dx1-0.5)
	aux=(0.1-2.*yy)/(4.*width)
	aux4=abs(aux**2)
        strg1(i,j,k)=exp(-aux4)*(strg1(i,j,k)-0.5)
        strg2(i,j,k)=exp(-aux4)*(strg2(i,j,k)-0.5)
        strg3(i,j,k)=exp(-aux4)*(strg3(i,j,k)-0.5)
	omg1(i,j,k)=0.
	omg2(i,j,k)=0.
	omg3(i,j,k)=0.
	ug(i,j,k)=0.
        enddo
        enddo
        enddo

        vxmax=0.

        do i=1,nx1
	xx=float(i-1)*dx1
        do k=1,nz1
	zz=float(k-1)*dx1
        do j=1,ny1
        yy=abs(float(j-1)*dx1-0.5)
        aux=(0.1-2.*yy)/(4.*width)
c        vxg(i,j,k)=0.5*(1.+tanh(aux))*(1.+ampl*strg1(i,j,k))
        vxg(i,j,k)=0.5*(1.+tanh(aux))*(1.+ampl3*sin(4*pi2*(xx)))
	vxg(i,j,k)=vxg(i,j,k)*(1.+ampl*strg1(i,j,k))
        vyg(i,j,k)=ampl*strg2(i,j,k)
        vzg(i,j,k)=ampl*strg3(i,j,k)
        vxmax=amax1(vxmax,abs(vxg(i,j,k)))
        enddo
        enddo
        enddo

	print*, 'VXMAX =', VXMAX

	dxinv=0.5/dx1
	npart=0
	do 10 i=1,nx1
        it=mod(i+nx1,nx1)+1
        ib=mod(i-2+nx1,nx1)+1
        xx=(float(i)-1.)*dx1     
	do 10 j=1,ny1
       jt=mod(j+ny1,ny1)+1
       jb=mod(j-2+ny1,ny1)+1
        yy=(float(j)-1.)*dx1     
	do 10 k=1,nz1
       kt=mod(k+nz1,nz1)+1
       kb=mod(k-2+nz1,nz1)+1
        zz=(float(k)-1.)*dx1     
        dwdx=vzg(it,j,k)-vzg(ib,j,k)
        dwdy=vzg(i,jt,k)-vzg(i,jb,k)
        dudy=vxg(i,jt,k)-vxg(i,jb,k)
        dudz=vxg(i,j,kt)-vxg(i,j,kb)
        dvdx=vyg(it,j,k)-vyg(ib,j,k)
        dvdz=vyg(i,j,kt)-vyg(i,j,kb)
	aux3=(dvdx-dudy)*dxinv
	aux1=(dwdy-dvdz)*dxinv
	aux2=(dudz-dwdx)*dxinv
ccc
! aux1=0.
! aux2=0.
	omg1(i,j,k)=aux1
	omg2(i,j,k)=aux2
	omg3(i,j,k)=aux3
	if (abs(aux1)+abs(aux2)+abs(aux3).gt.0.0001) then
	npart=npart+1
	xp1(npart)=xx
	yp1(npart)=yy
	zp1(npart)=zz
	dv1(npart)=dx1*dx1*dx1
	omx(npart)=dv1(npart)*aux1
	omy(npart)=dv1(npart)*aux2
	omz(npart)=dv1(npart)*aux3
	circ=circ+omz(npart)
	endif
10	continue
	print*, 'NPART =', npart
	do i=1,npart
! omz(npart)=omz(npart)-circ/float(npart)
	enddo

	tm=0.
        do k=1,nz2
        do j=1,ny2
        yy=abs(float(j-1)*dx2-0.5)
        aux=(0.1-2.*yy)/(4.*width)
        aux2=aux**2
        do i=1,nx2
        ug(i,j,k)=0.
c        ug(i,j,k)=1.
        val=0.5*(1.+tanh(aux))*(1.+ampl2*strg3(i,j,k))
        if (val.gt.0.0001) then
        npart_rho=npart_rho+1
        ug(i,j,k)=val
	tm=tm+val
c        ug(i,j,k)=1.
        endif
        enddo
        enddo
        enddo

	print*, ' MASSE SCALAIRE a init ',tm*dx2*dx2*dx2
	return
	end
