        subroutine remeshy(np1,xp1,up1,itype,jj,kk)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	dimension xp1(*),up1(*),itype(*)



! remaillage des particules fluides

	dxinv=1./dx2

	do i=1,nx2
	ug(jj,i,kk)=0.
	enddo

         x0=xmin

         do n = 1,np1
            g1 = up1(n)
            x = xp1(n)
			
            ip1 = int((x-x0)*dxinv)
            ip0 = ip1 - 1
            ip2 = ip1 + 1
            ip3 = ip1 + 2

! print*, ' IPO ..',n,xp1(n),ip0,ip1,ip2

           xx1 = (x - float(ip1)*dx2-x0)*dxinv
           xx0=xx1+1
           xx2=1-xx1
           xx3=2.-xx1

        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
        ip3=mod(ip3+nx2,nx2) +1
c
c     left-M'4:
c
           a0 = .5*((2.-xx0)**2)*(1.-xx0)
           a1 = 1.-2.5*xx1*xx1 +  1.5*xx1*xx1*xx1
           a2 = 1.-2.5*xx2*xx2 +  1.5*xx2*xx2*xx2
           a3 = .5*((2.-xx3)**2)*(1.-xx3)

           ug(jj,ip0,kk) = ug(jj,ip0,kk) + g1*a0
           ug(jj,ip1,kk) = ug(jj,ip1,kk) + g1*a1
           ug(jj,ip2,kk) = ug(jj,ip2,kk) + g1*a2
           ug(jj,ip3,kk) = ug(jj,ip3,kk) + g1*a3
		   
	enddo

        RETURN
        END



