        subroutine remeshz(np1,xp1,up1,itype,jj,kk)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	dimension xp1(*),up1(*),itype(*)

c	remaillage des particules fluides

	dxinv=1./dx2

	do i=1,nx2
	ug(jj,kk,i)=0.
	enddo

         x0=xmin

         do n = 1,np1
            g1 = up1(n)
            x = xp1(n)
			
            ip1 = int((x-x0)*dxinv)
	    ip0 = ip1 - 1
            ip2 = ip1 + 1
            ip3 = ip1 - 2
            ip4 = ip1 + 2
            ip5 = ip1 + 3

           xx1 = (x - float(ip1)*dx2-x0)*dxinv
           xx0=xx1+1.
           xx2=-xx1+1.
           xx3=xx1+2.
           xx4=-xx1+2.
           xx5=-xx1+3.


        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
        ip3=mod(ip3+nx2,nx2) +1
        ip4=mod(ip4+nx2,nx2) +1
        ip5=mod(ip5+nx2,nx2) +1
c
c     M'6
c
        a0 =(xx0-1.)*(xx0-2.)*(25.*xx0**3-114.*xx0**2+153.*xx0-48.)/24.
        a1 =-(xx1-1.)*(25.*xx1**4-38.*xx1**3-3.*xx1**2+12.*xx1+12)/12.
        a2 =-(xx2-1.)*(25.*xx2**4-38.*xx2**3-3.*xx2**2+12.*xx2+12)/12.
        a3 =-(xx3-2)*(5.*xx3-8.)*(xx3-3.)**3/24.
        a4 =(xx4-1.)*(xx4-2.)*(25.*xx4**3-114.*xx4**2+153.*xx4-48.)/24.
        a5 =-(xx5-2)*(5.*xx5-8.)*(xx5-3.)**3/24.

           ug(jj,kk,ip0) = ug(jj,kk,ip0) + g1*a0
           ug(jj,kk,ip1) = ug(jj,kk,ip1) + g1*a1
           ug(jj,kk,ip2) = ug(jj,kk,ip2) + g1*a2
           ug(jj,kk,ip3) = ug(jj,kk,ip3) + g1*a3
           ug(jj,kk,ip4) = ug(jj,kk,ip4) + g1*a4
           ug(jj,kk,ip5) = ug(jj,kk,ip5) + g1*a5
		   
	enddo

	go to 222
	do k=3,nx2-2
	do j=1,nx2
	do i=1,nx2
	if (ug(i,j,k).gt.1.2) then
	print*,'BOUM', i,j,k,ug(i,j,k)
	goto 222
	endif
	enddo
	enddo
	enddo

222	continue
        RETURN
        END



