	subroutine veloxaux(vmax,dvmax)

c	version de veloxaux ou on prend les 32 premiers
c	modes de la vitesse, on padde avec des 0 jusqu'a nx2 (128 ou 256)
c	 et on fait fft inverse sur une grille nx2

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        parameter(npg2=npg)
        parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

	dimension aux1(npg2,npg2,npg2),aux2(npg2,npg2,npg2)
	dimension aux3(npg2,npg2,npg2)

        parameter(npgb2=npg2/2)

       complex cfx,cfy,cfz,cux,cuy,cuz,wk
        common/fft/cfx(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cux(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz)

        complex cvx,cvy,cvz,wk2
        dimension cvx(0:npgb2,1-npgb2:npgb2,1-npgb2:npgb2),
     1             cvy(0:npgb2,1-npgb2:npgb2,1-npgb2:npgb2),
     1             cvz(0:npgb2,1-npgb2:npgb2,1-npgb2:npgb2),
     1             wk2(npgb2+1,npg2,npg2)

	dx3=(xmax-xmin)/float(nx3)

	goto 113
c	 si on veut pas filter ..

	do k=1,nx1
	do j=1,nx1
	do i=1,nx1
	aux1(i,j,k)=-vxg(i,j,k)
	aux2(i,j,k)=-vyg(i,j,k)
	aux3(i,j,k)=-vzg(i,j,k)
	enddo
	enddo
	enddo

	go to 112

113	continue

        pi=3.1415926

        nxb2=nx3/2
        nyb2=nx3/2
        nzb2=nx3/2
        nxb2=32
        nyb2=32
        nzb2=32
        nxb=nx1/2
        nyb=nx1/2
        nzb=nx1/2

      do 20 k=1-nzb,nzb
         do 20 j=1-nyb,nyb
            do 20 i=0,nxb
      cvx(i,j,k)=0.
      cvy(i,j,k)=0.
      cvz(i,j,k)=0.
20    continue

      do 10 k=1-nzb2,nzb2
         do 10 j=1-nyb2,nyb2
            do 10 i=0,nxb2
      cvx(i,j,k)=cux(i,j,k)
      cvy(i,j,k)=cuy(i,j,k)
      cvz(i,j,k)=cuz(i,j,k)
10    continue

c      call fftw3d(aux3,cvz,nx3,nx3,nx3,nxb2,nyb2,nzb2,wk2,1)
c      call fftw3d(aux2,cvy,nx3,nx3,nx3,nxb2,nyb2,nzb2,wk2,1)
c      call fftw3d(aux1,cvx,nx3,nx3,nx3,nxb2,nyb2,nzb2,wk2,1)
      call fftw3d(aux3,cvz,nx1,nx1,nx1,nxb,nyb,nzb,wk2,1)
      call fftw3d(aux2,cvy,nx1,nx1,nx1,nxb,nyb,nzb,wk2,1)
      call fftw3d(aux1,cvx,nx1,nx1,nx1,nxb,nyb,nzb,wk2,1)

c	ecriture fhciers grille  NX2

112	continue

	umax1=0.
	umax2=0.
	umax3=0.
	dvmax=0.
	dvxmax=0.
	dvymax=0.
	dvzmax=0.
        do k=1,nx3
        do j=1,nx3
        do i=1,nx3
        psi1(i,j,k)=-aux1(i,j,k)
	umax1=amax1(umax1,abs(psi1(i,j,k)))
        psi2(i,j,k)=-aux2(i,j,k)
	umax2=amax1(umax2,abs(psi2(i,j,k)))
        psi3(i,j,k)=-aux3(i,j,k)
	umax3=amax1(umax3,abs(psi3(i,j,k)))
        enddo
        enddo
        enddo

        do k=1,nx3
        kt=mod(k,nx3)+1
        do j=1,nx3
        jt=mod(j,nx3)+1
        do i=1,nx3
        it=mod(i,nx3)+1
        dvxmax=amax1(dvxmax,abs(psi1(it,j,k)-psi1(i,j,k)))
        dvymax=amax1(dvymax,abs(psi2(i,jt,k)-psi2(i,j,k)))
        dvzmax=amax1(dvzmax,abs(psi3(i,j,kt)-psi3(i,j,k)))
        enddo
        enddo
        enddo

	dvmax=amax1(dvxmax,dvymax)
	dvmax=amax1(dvmax,dvzmax)/dx3

	print*,'umax', umax1,umax2,umax3
	print*,'DVMAXs ',dvxmax/dx3,dvymax/dx3,dvzmax/dx3

	vmax=amax1(umax1,umax2,umax3)

	goto 111

      open(20,file='datavelx',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
        write(20)  ((((psi1(i,j,k)),
     1                i=1,nx3),j=1,nx3),k=1,nx3)
      open(21,file='datavely',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
        write(21)  ((((psi2(i,j,k)),
     1                i=1,nx3),j=1,nx3),k=1,nx3)
      open(22,file='datavelz',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
        write(22)  ((((psi3(i,j,k)),
     1                i=1,nx3),j=1,nx3),k=1,nx3)
        close(20)
        close(21)
        close(22)

111	continue



	return
	end
