        program cylindre

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp(npm),yp(npm),zp(npm),dv(npm)
        dimension omx(npm),omy(npm),omz(npm)
	dimension vx(npm),vy(npm),vz(npm) 
        dimension strx(npm),stry(npm),strz(npm)

	dimension domx(npm),domy(npm),domz(npm)
c       tableuax supplementaries pour RK
      dimension xp0(npm),yp0(npm),zp0(npm)
      dimension om1(npm),om2(npm),om3(npm)
      dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
      dimension vxv(4,npm),vyv(4,npm),vzv(4,npm)  
      dimension para(4)
      dimension enstrophy(0:1000),energy(0:1000),divergence(0:1000)  

      data (para(i),i=1,4)/0.5,0.5,1.,0./

        character*30 filevelx,filevely,filevelz


        pi=3.1415926
        pi2=2.*pi






        OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx
        READ(1,*)
        read(1,*)tstop
        READ(1,*)
        read(1,*)coef
        READ(1,*)
        read(1,*)anu
        READ(1,*)
        read(1,*)coef_les
        READ(1,*)
        read(1,*)tvisu
        READ(1,*)
        read(1,*) width


	close(1)
	tvisu=0.3
	idif=1

	xmin=-0.
	xmax=1.
	ymin=0.
	ymax=1.
	zmin=xmin
	zmax=xmax

	ny=nx
	nz=nx
	dx=(xmax-xmin)/(nx)
	dy=(ymax-ymin)/(ny)
	dz=(zmax-zmin)/(nz)

	delt=0.01


	call init(npart,xp,yp,zp,omx,omy,omz,dv)

        OPEN(33,file='SPEED',status='unknown')

c       debut des iterations

	time=0.
	tcompt=0.
	istep=0
	nit=10000

        do 20 kk=1,nit

	time=time+delt

	deltconv=delt
        delt1=delt/6.  

        call velox_fft
	call vfix
c        call vhat(delt)

	print*, ' VITESSE = ',vzh

        call pen(coef_pen,omx,omy,omz,delt)
c        call bar(saut)

        call stretch

	

c     on fait les sous-iterations R.K.

        do 10 i=1,npart
          xp0(i)=xp(i)
          yp0(i)=yp(i)
          zp0(i)=zp(i)
          om1(i)=omx(i)
          om2(i)=omy(i)
          om3(i)=omz(i)
10     continue  

      do  550 ll=1,4     

       call intervm4(npart,vx,vy,vz,xp,yp,zp)
       call intersm4(npart,strx,stry,strz,xp,yp,zp)   

c       increment des positions et poids correspondant aux sous-ite
c       RK
c **********************

        vxmax=0.
        vxmax=-10000.
        vxmin=10000.
        vymax=-10000.
        vymin=10000.
        vzmax=-10000.
        vzmin=10000.
        vzmax=0.
        do 520 i=1,npart
         vxv(ll,i)=vx(i)
         vyv(ll,i)=vy(i)
         vzv(ll,i)=vz(i)
         strxv(ll,i)=dv(i)*strx(i)
         stryv(ll,i)=dv(i)*stry(i)
         strzv(ll,i)=dv(i)*strz(i)
         xp(i)=xp0(i)+para(ll)*deltconv*vx(i)
         if (xp(i).lt.xmin) xp(i)=xp(i)+xmax-xmin
         if (xp(i).gt.xmax) xp(i)=xp(i)-xmax+xmin
         yp(i)=yp0(i)+para(ll)*deltconv*vy(i)
         if (yp(i).lt.ymin) yp(i)=yp(i)+ymax-ymin
         if (yp(i).gt.ymax) yp(i)=yp(i)-ymax+ymin
         zp(i)=zp0(i)+para(ll)*deltconv*vz(i)
         if (zp(i).lt.zmin) zp(i)=zp(i)+zmax-zmin
         if (zp(i).gt.zmax) zp(i)=zp(i)-zmax+zmin
         omx(i)=om1(i)+para(ll)*deltconv*dv(i)*strx(i)
         omy(i)=om2(i)+para(ll)*deltconv*dv(i)*stry(i)
         omz(i)=om3(i)+para(ll)*deltconv*dv(i)*strz(i)
        vxmax=amax1(vxmax,(vx(i)))
        vxmin=amin1(vxmin,(vx(i)))
        vymax=amax1(vymax,(vy(i)))
        vymin=amin1(vymin,(vy(i)))
        vzmax=amax1(vzmax,(vz(i)))
        vzmin=amin1(vzmin,(vz(i)))
520   continue
c       print*,' vitesses max ',vxmax,vxmin,vymax,vymin,vzmax,vzmin

550   continue

c       FIN des sous-ite RK
c **********************

c       Increments des positions et poids pour
c       la partie transport-deformation du tourbillon


	xleft=xmax
	xright=xmin
	yleft=ymax
	yright=ymin
	zleft=zmax
	zright=zmin
       do 900 i=1,npart
          xp(i)=xp0(i)+delt1*(vxv(1,i)+2.*vxv(2,i)+2.*vxv(3,i)+vxv(4,i))
          yp(i)=yp0(i)+delt1*(vyv(1,i)+2.*vyv(2,i)+2.*vyv(3,i)+vyv(4,i))
          zp(i)=zp0(i)+delt1*(vzv(1,i)+2.*vzv(2,i)+2.*vzv(3,i)+vzv(4,i))
	zp(i)=zp(i)-delt*vzh
        xleft=amin1(xleft,xp(i))
        xright=amax1(xright,xp(i))
        yleft=amin1(yleft,yp(i))
        yright=amax1(yright,yp(i))
        zleft=amin1(zleft,zp(i))
        zright=amax1(zright,zp(i)) 
         if (xp(i).lt.xmin) xp(i)=xp(i)+xmax-xmin
         if (xp(i).gt.xmax) xp(i)=xp(i)-xmax+xmin  
         if (yp(i).lt.ymin) yp(i)=yp(i)+ymax-ymin
         if (yp(i).gt.ymax) yp(i)=yp(i)-ymax+ymin
         if (zp(i).lt.zmin) zp(i)=zp(i)+zmax-zmin
         if (zp(i).gt.zmax) zp(i)=zp(i)-zmax+zmin 
       omx(i)=om1(i)+delt1*(strxv(1,i)+2.*strxv(2,i)+
     1            2.*strxv(3,i)+strxv(4,i))
       omy(i)=om2(i)+delt1*(stryv(1,i)+2.*stryv(2,i)+
     1            2.*stryv(3,i)+stryv(4,i))                
       omz(i)=om3(i)+delt1*(strzv(1,i)+2.*strzv(2,i)+
     1            2.*strzv(3,i)+strzv(4,i))
900    continue




c     Remshing +  Diffusion
c ********************** 

c	circlim=0.0001
c	circulation mimimum pour troncature de la vorticite dans remaillage
	circlim=-10.
	

	call  remeshdif(npart,circlim,omx,omy,omz,
     1             xp,yp,zp,dv,anu,delt)   

        print*,' npart apres remeshing ', kk,npart

	xg=0.
	yg=0.
	zg=0.
	tm=0.

        if ((tcompt.gt.tvisu).or.(kk.eq.0)) then
        istep=istep+1     
        print*, ' ****** IMPRESSION des RESULTATS: ',  istep, ' ******'

        write(filevelx,140)istep
140     format('velx',i1)
        if (istep.ge.10) then
         write(filevelx,141)istep
        endif
141     format('velx',i2)  
        write(filevely,150)istep
150     format('vely',i1)
        if (istep.ge.10) then
         write(filevely,151)istep
        endif
151     format('vely',i2)  
        write(filevelz,160)istep
160     format('velz',i1)
        if (istep.ge.10) then
         write(filevelz,161)istep
        endif
161     format('velz',i2)  

      open(2,file=filevelx,form='unformatted',
c     1       convert='big_endian',
     1       status='unknown')
      open(3,file=filevely,form='unformatted',
c     1       convert='big_endian',
     1       status='unknown')
      open(4,file=filevelz,form='unformatted',
c     1       convert='big_endian',
     1       status='unknown')
        write(2)  (((vxg(i,j,k),
     1                i=1,nx),j=1,ny),k=1,nz)
        write(3)  (((vyg(i,j,k),
     1                i=1,nx),j=1,ny),k=1,nz)
        write(4)  (((vzg(i,j,k),
     1                i=1,nx),j=1,ny),k=1,nz)
        close(2)  
        close(3)  
        close(4)  
	
        tcompt=0.
         endif    

        write(32,*) time,vzh

	if (time.gt.5.) goto 201

20	continue

201	continue
	stop
	end

