module resultats_mod
  use donnees_mod
  use tab_mod
contains 


    subroutine res_vtk_q (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A8)')""
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A15)') "SCALARS U FLOAT"
      write(11,'(A20)') "LOOKUP_TABLE DEFAULT" 


      !ordre i,k,j pour plot vtk de la sphere "droit"
      do i=1,nx
         do k=1,nz     
            do j=1,ny
               write(11,'(f20.9)') real(qg(i,j,k))
            end do
         end do
      end do
     

      close (11)

    end subroutine res_vtk_q

    subroutine res_vtk (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A8)')""
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A15)') "SCALARS U FLOAT"
      write(11,'(A20)') "LOOKUP_TABLE DEFAULT" 


      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(f20.9)') real(qg(i,j,k))
            end do
         end do
      end do

      write(11,'(A21)') ""
      write(11,'(A21)') "VECTORS VITESSE FLOAT" 

      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(vxg(i,j,k)),real(vyg(i,j,k)),real(vzg(i,j,k))
            end do
         end do
      end do

      close (11)

    end subroutine res_vtk




end module resultats_mod

