reset
set auto

vol_theo = 4.0*pi*0.15*0.15*0.15/3.0

set title "Volume en fonction du temps"
set xl 'temps'
set yl 'volume'
set ytics nomirror
set y2l 'erreur relative'
set y2tics
set key outside bottom center maxrows 1 box height 1
set yr [0:*]

p'volume.dat' u ($0*0.07):1 w lp t 'volume' axes x1y1,\
  (vol_theo) t'volume théorique' axes x1y1, \
  'volume.dat' u ($0*0.07):(abs($1-vol_theo)/vol_theo) t 'erreur' w lp axes x1y2

l'loop.gp'