
inline float4 alpha(float4 y, float4 s){
  return (y * (y * (y * (y * (13.0 - 5.0 * y) - 9.0) - 1.0) + 2.0) / 24.0) * s;}
inline float4 beta(float4 y, float4 s){
  return (y * (y * (y * (y * (25.0 * y - 64.0) + 39.0) + 16.0) - 16.0) / 24.0)*s;}
inline float4 gamma(float4 y, float4 s){
  return (y * y * (y * (y * (126.0 - 50.0 * y) - 70.0) - 30.0) / 24.0 + 1.0)*s;}
inline float4 delta(float4 y, float4 s){
  return (y * (y * (y * (y * (50.0 * y - 124.0) + 66.0) + 16.0) + 16.0) / 24.0)*s;}
inline float4 eta(float4 y, float4 s){
  return (y * (y * (y * (y * (61.0 - 25.0 * y) - 33.0) - 1.0) - 2.0) / 24.0)*s;}
inline float4 zeta(float4 y, float4 s){
  return (y * y * y * (y * (5.0 * y - 12.0) + 7.0) / 24.0)*s;}
