module interf2ppm
  
  use ppm_module_init
  use ppm_module_finalize
  use ppm_module_data
  use mpi
  
  implicit none
  
contains
  
  subroutine init(dime,prec,tol,debug)
    
    integer, intent(in) :: dime
    integer, intent(in) :: prec
    integer, intent(in) :: tol
    integer, intent(in) :: debug
    
    integer :: info, comm
    comm = MPI_COMM_WORLD

    call ppm_init(dime,prec,tol,comm,debug,info)
    
  end subroutine init

  subroutine finalize(info)
    integer, intent(out) :: info
    
    call ppm_finalize(info)
    
  end subroutine finalize

end module interf2ppm
