        program cylindre

c	versnio de main avec splitting x,y,z du transport/remesh de rho
c	le poussuer/remaille de om et rho sont dissocies

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp1(npm),yp1(npm),zp1(npm),dv1(npm)
        dimension xp2(npm),yp2(npm),zp2(npm)
        dimension omx(npm),omy(npm),omz(npm)
        dimension vx1(npm),vy1(npm),vz1(npm)
        dimension vx2(npm),vy2(npm),vz2(npm)
        dimension strx(npm),stry(npm),strz(npm)
	dimension phip(npm)
c       tableuax supplementaries pour RK
      dimension xp10(npm),yp10(npm),zp10(npm)
      dimension xp20(npm),yp20(npm),zp20(npm)
      dimension om1(npm),om2(npm),om3(npm)
      dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
      dimension vxv1(4,npm),vyv1(4,npm),vzv1(4,npm)
      dimension vxv2(4,npm),vyv2(4,npm),vzv2(4,npm)

      dimension para(4)
      dimension enstrophy(0:10000),energy(0:10000),divergence(0:10000)  

      data (para(i),i=1,4)/0.5,0.5,1.,0./

        character*30 filerho,fileomx,fileomy,fileomz


        pi=3.1415926
        pi2=2.*pi

        OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2
        READ(1,*)
        read(1,*)nit
        READ(1,*)
        read(1,*)anu
        READ(1,*)
        read(1,*)anu_rho
        READ(1,*)
        read(1,*)coef_les
        READ(1,*)
        read(1,*)korder
        READ(1,*)
        read(1,*)tstop
        close(1)
        idif=1
		iper=0


        xmin=0.
        ymin=0.
        zmin=0.
        xmax=pi2
	xmax=1.
        ymax=xmax
        dx1=(xmax-xmin)/float(nx1)
        dx2=(xmax-xmin)/float(nx2)
        zmax=xmax

	circlim=0.00001
	nx=nx1
	dx=dx1

        t1=0.6
        t2=1.4
c        t3=0.784
c        t4=1.13
	t3=1000.
	t4=1000.
        
	t1=3.4
	t2=3.8
	t3=3.6
	t4=5.
c	resolution pour rho
c	et initalisation des comptuer utlise pour 
c	avoir des pas de temps distincts en rho et omega

	nx3=nx1
	dx3=(xmax-xmin)/float(nx3)

        dy1=dx1
        dz1=dx1
        ny1=nx1
        nz1=nx1
        dy2=dx2
        dz2=dx2
        ny2=nx2
        nz2=nx2

	print*, nx1,ny1,nz1,xmax,ymax,zmax



	call init_burgers

        OPEN(33,file='DIAG1',status='unknown')
        OPEN(34,file='DIAG2',status='unknown')

c       debut des iterations

	time=0.
	tcompt=0.
	istep=0

        do 20 kk=1,nit
	
	call velox_burgers(vmax,dvmax)
	print*,' time, VMAX, DVmax = ',time,vmax,dvmax,dvmax/dx3

c	determination pas de temps:
        delt3=0.4*dx3/vmax
c	delt3=0.
        if (dvmax.ne.0.) delt3=amax1(delt3,0.2*dx3/dvmax)
        print*,' CFLs ',delt3*vmax/dx3
	dt=delt3
	np_bl=1


        call x_advect(dt,np_bl,npart_rho,ntagx)

	ntag=max(ntagx,ntagy)
	ntag=max(ntag,ntagz)

223	continue

	time=time+dt
	if (time.gt.tstop) goto 202

20	continue

202	continue

        do i=1,nx2
                umax=amax1(umax,abs(ug(i,j,k)))
                write(33,*) psi1(i,5,5)
                write(34,*) ug(i,5,5)
        enddo
        close(33)



201	continue
	stop
	end

