        program cylindre

c	versnio de main avec splitting x,y,z du transport/remesh de rho
c	le poussuer/remaille de om et rho sont dissocies
c	comma main_full, mais avec cfl 0.5 pour advection de rho
c	(et  possibilite de sous-ite pour advection de rho avec dt3 < dt)

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp1(npm),yp1(npm),zp1(npm),dv1(npm)
        dimension xp2(npm),yp2(npm),zp2(npm)
        dimension omx(npm),omy(npm),omz(npm)
        dimension vx1(npm),vy1(npm),vz1(npm)
        dimension vx2(npm),vy2(npm),vz2(npm)
        dimension strx(npm),stry(npm),strz(npm)
	dimension phip(npm)
c       tableuax supplementaries pour RK
      dimension xp10(npm),yp10(npm),zp10(npm)
      dimension xp20(npm),yp20(npm),zp20(npm)
      dimension om1(npm),om2(npm),om3(npm)
      dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
      dimension vxv1(4,npm),vyv1(4,npm),vzv1(4,npm)
      dimension vxv2(4,npm),vyv2(4,npm),vzv2(4,npm)

      dimension para(4)
      dimension enstrophy(0:10000),energy(0:10000),divergence(0:10000)  

      data (para(i),i=1,4)/0.5,0.5,1.,0./

        character*30 filerho,fileomx,fileomy,fileomz


        pi=3.1415926
        pi2=2.*pi

        OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2
        READ(1,*)
        read(1,*)nit
        READ(1,*)
        read(1,*)anu
        READ(1,*)
        read(1,*)anu_rho
        READ(1,*)
        read(1,*)coef_les
        READ(1,*)
        read(1,*)korder
        READ(1,*)
        read(1,*)tstop
        close(1)
        idif=1
		iper=0

	drho=10.
	drho=0.

        xmin=0.
        ymin=0.
        zmin=0.
        xmax=pi2
	xmax=1.
        ymax=xmax
        dx1=xmax/float(nx1)
        dx2=xmax/float(nx2)
        zmax=xmax

	nx=nx2
	dx=dx2

        t1=0.5
	dtcompt=0.05
        t2=0.15
	t3=0.2
	t4=0.25
	t5=0.3
        
c	resolution pour rho
c	et initalisation des comptuer utlise pour 
c	avoir des pas de temps distincts en rho et omega

	nx3=32
c	cas ou on utilise veloxax_v2 (filtre en spectral
c	puis on padde avec des 0 puis on fftinverse sur une
c	grille 128 ou 256:
	nx3=nx1

	dx3=xmax/float(nx3)
	ic=0
	k_delt3=1
 
        dy1=dx1
        dz1=dx1
        ny1=nint(float(nx1)*ymax/xmax)
        nz1=nint(float(nx1)*zmax/xmax)
        ymax=float(ny1)*dy1
        zmax=float(nz1)*dz1
        dy2=dx2
        dz2=dx2
        ny2=nint(float(nx2)*ymax/xmax)
        nz2=nint(float(nx2)*zmax/xmax)

	print*, nx1,ny1,nz1,xmax,ymax,zmax


c	dt max pour diffusion
	dtmax=0.5*dx1*dx1/anu
	delt0=1.5*dx1
	delt0=0.0001
	delt=delt0
	delt3=delt
c	delt=0.0

	call bubble(npart1,xp1,yp1,zp1,
     1                 omx,omy,omz,dv1)

	print*,'npart1 ',npart1

        OPEN(33,file='DIAG1',status='unknown')
        OPEN(34,file='DIAG2',status='unknown')

c       debut des iterations

	time=0.
	tcompt=0.
	omax=0.
	istep=0

	dt=0.01
	tau=0.1
	jc=8
	call stension(tau,jc)
	do k=1,nx1
	do j=1,nx1
	do i=1,nx1
	omg1(i,j,k)=dt*strg1(i,j,k)
	omg2(i,j,k)=dt*strg2(i,j,k)
	omg3(i,j,k)=dt*strg3(i,j,k)
	enddo
	enddo
	enddo

	call velox(vmax1)
	call veloxaux(vmax,dvmax)



                      open(24,file='filerho')
	umax=0.
            WRITE(24,'(A)') "# vtk DataFile Version 3.0"
        WRITE(24,'(A)') "Scalar"
        WRITE(24,'(A)') "ASCII"
        WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
        WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx2," ",nx2," ",nx2
        WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
        WRITE(24,*) "SPACING"," ",dx2," ",dx2," ",dx2
        WRITE(24,*) "POINT_DATA ",nx2*nx2*nx2
        WRITE(24,'(A)') "SCALARS omg float"
        WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
        do k=1,nx2
        do j=1,nx2
        do i=1,nx2
                umax=amax1(umax,abs(ug(i,j,k)))
                write(24,*) amax1(0.00001,ug(i,j,k))
        enddo
        enddo
        enddo
	close(24)
                      open(24,file='filevelox')
        umax=0.
            WRITE(24,'(A)') "# vtk DataFile Version 3.0"
        WRITE(24,'(A)') "Scalar"
        WRITE(24,'(A)') "ASCII"
        WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
        WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx2," ",nx2," ",nx2
        WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
        WRITE(24,*) "SPACING"," ",dx2," ",dx2," ",dx2
        WRITE(24,*) "POINT_DATA ",nx2*nx2*nx2
        WRITE(24,'(A)') "SCALARS omg float"
        WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
        do k=1,nx2
        do j=1,nx2
        do i=1,nx2
	uu=sqrt(vxg(i,j,k)**2+vyg(i,j,k)**2+vzg(i,j,k)**2)
c	uu=sqrt(psi1(i,j,k)**2+psi2(i,j,k)**2+psi3(i,j,k)**2)
                write(24,*) amax1(0.00001,uu)
        enddo
        enddo
        enddo
        close(24)

	stop
	end

