        program cylindre

c	versnio de main avec splitting x,y,z du transport/remesh de rho
c	le poussuer/remaille de om et rho sont dissocies

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp1(npm),yp1(npm),zp1(npm),dv1(npm)
        dimension xp2(npm),yp2(npm),zp2(npm)
        dimension omx(npm),omy(npm),omz(npm)
        dimension vx1(npm),vy1(npm),vz1(npm)
        dimension vx2(npm),vy2(npm),vz2(npm)
        dimension strx(npm),stry(npm),strz(npm)
	dimension phip(npm)
c       tableuax supplementaries pour RK
      dimension xp10(npm),yp10(npm),zp10(npm)
      dimension xp20(npm),yp20(npm),zp20(npm)
      dimension om1(npm),om2(npm),om3(npm)
      dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
      dimension vxv1(4,npm),vyv1(4,npm),vzv1(4,npm)
      dimension vxv2(4,npm),vyv2(4,npm),vzv2(4,npm)

      dimension para(4)
      dimension enstrophy(0:10000),energy(0:10000),divergence(0:10000)  

      data (para(i),i=1,4)/0.5,0.5,1.,0./

        character*30 filerho,fileomx,fileomy,fileomz


        pi=3.1415926
        pi2=2.*pi

        OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2
        READ(1,*)
        read(1,*)nit
        READ(1,*)
        read(1,*)anu
        READ(1,*)
        read(1,*)anu_rho
        READ(1,*)
        read(1,*)coef_les
        READ(1,*)
        read(1,*)tstop
        close(1)
        idif=1
	iper=0


        xmin=0.
        ymin=0.
        zmin=0.
        xmax=pi2
        ymax=xmax
        dx1=xmax/float(nx1)
        dx2=xmax/float(nx2)
        zmax=16.*dx1
        zmax=0.5
        zmax=xmax
        yt=0.55
        yb=0.45
c	yt=1.
c	yb=0.

        t1=0.6
	t2=1.4
c        t3=0.784
c        t4=1.13
	t3=0.
	t4=0.
        
c	resolution pour rho
c	et initalisation des comptuer utlise pour 
c	avoir des pas de temps distincts en rho et omega

	nx3=32
	dx3=xmax/float(nx3)
	ic=0
	k_delt3=1
 
        dy1=dx1
        dz1=dx1
        ny1=nint(float(nx1)*ymax/xmax)
        nz1=nint(float(nx1)*zmax/xmax)
        ymax=float(ny1)*dy1
        zmax=float(nz1)*dz1
        dy2=dx2
        dz2=dx2
        ny2=nint(float(nx2)*ymax/xmax)
        nz2=nint(float(nx2)*zmax/xmax)

	print*, nx1,ny1,nz1,xmax,ymax,zmax

        j2=1+nint(yt/dx1)
        j1=1+nint(yb/dx1)
        yt=float(j2-1)*dx1
        yb=float(j1-1)*dx1

	delt0=1.5*dx1
	delt0=0.0001
	delt=delt0
	delt3=delt
c	delt=0.0

c	call jet(npart1,npart2,xp1,yp1,zp1,
c     1                 xp2,yp2,zp2,omx,omy,omz,phip,dv1)
	call readfield(npart1,npart2,xp1,yp1,zp1,
     1                 xp2,yp2,zp2,omx,omy,omz,phip,dv1)

	print*,'npart1,npart2 ',npart1,npart2
c	call stream
c	call velox_stream
	call velox
	call veloxaux(nx3,vmax)

        OPEN(33,file='VOLUMES',status='unknown')
        OPEN(34,file='DECAY')

c       debut des iterations

	time=0.
	tcompt=0.
	istep=0

        do 20 kk=1,nit
	
	time=time+delt

        deltconv=delt

        delt1=deltconv/6.  

c	ADVECTION particules de vorticite

c     on fait les sous-iterations R.K.

        do i=1,npart1
          xp10(i)=xp1(i)
          yp10(i)=yp1(i)
          zp10(i)=zp1(i)
          om1(i)=omx(i)
          om2(i)=omy(i)
          om3(i)=omz(i)
        enddo
        do i=1,npart2
          xp20(i)=xp2(i)
          yp20(i)=yp2(i)
          zp20(i)=zp2(i)
        enddo


      do  550 ll=1,4     

        if (ll.eq.1) then

        if (kk.ge.1) then


        print*,'TIME ',time

	endif

        call stretch

	endif

	nx4=nx1
	
       call intervm4(npart1,vx1,vy1,vz1,xp1,yp1,zp1,nx4)
       call intersm4(npart1,strx,stry,strz,xp1,yp1,zp1)


c       increment des positions et poids correspondant aux sous-ite
c       RK
c **********************

        vxmax=-10000.
        vxmin=10000.
        vymax=-10000.
        vymin=10000.
        vzmax=-10000.
        vzmin=10000.
        do 520 i=1,npart1
         vxv1(ll,i)=vx1(i)
         vyv1(ll,i)=vy1(i)
         vzv1(ll,i)=vz1(i)
         strxv(ll,i)=dv1(i)*strx(i)
         stryv(ll,i)=dv1(i)*stry(i)
         strzv(ll,i)=dv1(i)*strz(i)
         xp1(i)=xp10(i)+para(ll)*deltconv*vx1(i)
         if (xp1(i).lt.xmin) xp1(i)=xp1(i)+xmax-xmin
         if (xp1(i).gt.xmax) xp1(i)=xp1(i)-xmax+xmin
         yp1(i)=yp10(i)+para(ll)*deltconv*vy1(i)
         if (yp1(i).lt.ymin) yp1(i)=yp1(i)+ymax-ymin
         if (yp1(i).gt.ymax) yp1(i)=yp1(i)-ymax+ymin
         zp1(i)=zp10(i)+para(ll)*deltconv*vz1(i)
         if (zp1(i).lt.zmin) zp1(i)=zp1(i)+zmax-zmin
         if (zp1(i).gt.zmax) zp1(i)=zp1(i)-zmax+zmin
         omx(i)=om1(i)+para(ll)*deltconv*dv1(i)*strx(i)
         omy(i)=om2(i)+para(ll)*deltconv*dv1(i)*stry(i)
         omz(i)=om3(i)+para(ll)*deltconv*dv1(i)*strz(i)
        vxmax=amax1(vxmax,(vx1(i)))
        vxmin=amin1(vxmin,(vx1(i)))
        vymax=amax1(vymax,(vy1(i)))
        vymin=amin1(vymin,(vy1(i)))
        vzmax=amax1(vzmax,(vz1(i)))
        vzmin=amin1(vzmin,(vz1(i)))
520   continue

550   continue

c       FIN des sous-ite RK pour transport de vorticite
c **********************

	xpmin=10.
	ypmin=10.
	xpmax=0.
	ypmax=0.
	yleft=1000.
	yright=-1000.

       do i=1,npart1
          xp1(i)=xp10(i)+delt1*
     1           (vxv1(1,i)+2.*vxv1(2,i)+2.*vxv1(3,i)+vxv1(4,i))
          yp1(i)=yp10(i)+delt1*
     1           (vyv1(1,i)+2.*vyv1(2,i)+2.*vyv1(3,i)+vyv1(4,i))
          zp1(i)=zp10(i)+delt1*
     1           (vzv1(1,i)+2.*vzv1(2,i)+2.*vzv1(3,i)+vzv1(4,i))
         if (xp1(i).lt.xmin) xp1(i)=xp1(i)+xmax-xmin
         if (xp1(i).gt.xmax) xp1(i)=xp1(i)-xmax+xmin
         if (yp1(i).lt.ymin) yp1(i)=yp1(i)+ymax-ymin
         if (yp1(i).gt.ymax) yp1(i)=yp1(i)-ymax+ymin
         if (zp1(i).lt.zmin) zp1(i)=zp1(i)+zmax-zmin
         if (zp1(i).gt.zmax) zp1(i)=zp1(i)-zmax+zmin
       omx(i)=om1(i)+delt1*(strxv(1,i)+2.*strxv(2,i)+
     1            2.*strxv(3,i)+strxv(4,i))
       omy(i)=om2(i)+delt1*(stryv(1,i)+2.*stryv(2,i)+
     1            2.*stryv(3,i)+stryv(4,i))
       omz(i)=om3(i)+delt1*(strzv(1,i)+2.*strzv(2,i)+
     1            2.*strzv(3,i)+strzv(4,i))
	enddo

700    continue

c	fin d'adection de particules de vorticite


c

c     Remesh des particules de vorticite
C	puis diffusion de vorticite
c ********************** 

	circlim=0.0001
c	circlim=0.
	
	call  remesh_om(npart1,omx,omy,omz,
     1              xp1,yp1,zp1,dv1)
	print*,' npart OM apres remeshing ', kk,npart1
        call dif_om(npart1,circlim,omx,omy,omz,
     1              xp1,yp1,zp1,dv1,anu,delt,coef_les,omax)
	call velox
 
c	icrementation du comptuer pour decider ou non d
c	d'advecter/remailler en rho (pas de temps disticnts)
	ic=ic+1
	if (ic.eq.k_delt3) then

c	transport pour particules de rho avec RK2 splitte

c        call interho(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
        call interho_cic(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
	do i=1,npart2
	xp2(i)=xp20(i)+delt3*vx2(i)/2.
	yp2(i)=yp20(i)+delt3*vy2(i)/2.
	zp2(i)=zp20(i)+delt3*vz2(i)/2.
         if (xp2(i).lt.xmin) xp2(i)=xp2(i)+xmax-xmin
         if (xp2(i).gt.xmax) xp2(i)=xp2(i)-xmax+xmin
         if (yp2(i).lt.ymin) yp2(i)=yp2(i)+ymax-ymin
         if (yp2(i).gt.ymax) yp2(i)=yp2(i)-ymax+ymin
         if (zp2(i).lt.zmin) zp2(i)=zp2(i)+zmax-zmin
         if (zp2(i).gt.zmax) zp2(i)=zp2(i)-zmax+zmin
	enddo
        call interho(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
c        call interho_cic(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
	do i=1,npart2
	xp2(i)=xp20(i)+delt3*vx2(i)
	yp2(i)=yp20(i)
	zp2(i)=zp20(i)
         if (xp2(i).lt.xmin) xp2(i)=xp2(i)+xmax-xmin
         if (xp2(i).gt.xmax) xp2(i)=xp2(i)-xmax+xmin
	enddo

	call  remesh_rhox(npart2,circlim,phip,
     1              xp2,yp2,zp2)

	print*, 'NPART apres remesh_rhox ',npart2
        call interho(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
c        call interho_cic(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
	do i=1,npart2
	xp20(i)=xp2(i)
	yp20(i)=yp2(i)
	zp20(i)=zp2(i)
	xp2(i)=xp20(i)-delt3*vx2(i)/2.
	yp2(i)=yp20(i)+delt3*vy2(i)/2.
	zp2(i)=zp20(i)+delt3*vz2(i)/2.
         if (xp2(i).lt.xmin) xp2(i)=xp2(i)+xmax-xmin
         if (xp2(i).gt.xmax) xp2(i)=xp2(i)-xmax+xmin
         if (yp2(i).lt.ymin) yp2(i)=yp2(i)+ymax-ymin
         if (yp2(i).gt.ymax) yp2(i)=yp2(i)-ymax+ymin
         if (zp2(i).lt.zmin) zp2(i)=zp2(i)+zmax-zmin
         if (zp2(i).gt.zmax) zp2(i)=zp2(i)-zmax+zmin
	enddo
        call interho(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
c        call interho_cic(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
	do i=1,npart2
	xp2(i)=xp20(i)
	yp2(i)=yp20(i)+delt3*vy2(i)
	zp2(i)=zp20(i)
         if (yp2(i).lt.ymin) yp2(i)=yp2(i)+ymax-ymin
         if (yp2(i).gt.ymax) yp2(i)=yp2(i)-ymax+ymin
	enddo

	call  remesh_rhoy(npart2,circlim,phip,
     1              xp2,yp2,zp2)

        call interho(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
c        call interho_cic(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
	do i=1,npart2
	xp20(i)=xp2(i)
	yp20(i)=yp2(i)
	zp20(i)=zp2(i)
	xp2(i)=xp20(i)-delt3*vx2(i)/2.
	yp2(i)=yp20(i)-delt3*vy2(i)/2.
	zp2(i)=zp20(i)+delt3*vz2(i)/2.
         if (xp2(i).lt.xmin) xp2(i)=xp2(i)+xmax-xmin
         if (xp2(i).gt.xmax) xp2(i)=xp2(i)-xmax+xmin
         if (yp2(i).lt.ymin) yp2(i)=yp2(i)+ymax-ymin
         if (yp2(i).gt.ymax) yp2(i)=yp2(i)-ymax+ymin
         if (zp2(i).lt.zmin) zp2(i)=zp2(i)+zmax-zmin
         if (zp2(i).gt.zmax) zp2(i)=zp2(i)-zmax+zmin
	enddo
        call interho(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
c        call interho_cic(npart2,vx2,vy2,vz2,xp2,yp2,zp2,nx3)
	do i=1,npart2
	xp2(i)=xp20(i)
	yp2(i)=yp20(i)
	zp2(i)=zp20(i)+delt3*vz2(i)
        if (zp2(i).lt.zmin) zp2(i)=zp2(i)+zmax-zmin
		if (zp2(i).gt.zmax) zp2(i)=zp2(i)-zmax+zmin
	enddo

	call  remesh_rhoz(npart2,circlim,phip,
     1              xp2,yp2,zp2)

        print*,' npart RHO apres remeshing ', kk,npart2
c	si on met dif_rho, on peut mettre en commentaire la boucle
c	d'assignement a la fin de remesh_rhoz ..
        call dif_rho(npart2,circlim,phip,
     1              xp2,yp2,zp2,anu_rho,delt3,coef_les,rhomax)

c	Fin de push / remesh rho /dif rho
	call veloxaux(nx3,vmax)
        delt=.25/abs(omax)
	delt3=0.5*dx3/vmax
c	delt3=delt
	print*, ' Pas de temps omega et rho ', delt,delt3
	k_delt3=max(1,int(delt3/delt))
	delt3=float(k_delt3)*delt
	ic=0
	endif

        tcompt=tcompt+delt
       if (((time.gt.t1).and.(time.le.t1+1.5*delt)).
     1  or.((time.gt.t2).and.(time.le.t2+1.5*delt)).
     1  or.((time.gt.t4).and.(time.le.t4+1.5*delt)).
     1  or.((time.gt.t3).and.(time.le.t3+1.5*delt))) then
        istep=istep+1
        print*, ' ****** IMPRESSION des RESULTATS: ', istep,npart2, '*'
        write(filerho,140)istep
140     format('rho',i1)
        write(fileomx,141)istep
141     format('omx',i1)
        write(fileomy,142)istep
142     format('omy',i1)
        write(fileomz,143)istep
143     format('omz',i1)

      open(20,file=filerho,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(2,file=fileomx,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(3,file=fileomy,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(4,file=fileomz,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')

c	go to 333

        write(20)  (((rhog(i,j,k),
     1                i=1,nx2),j=1,ny2),k=1,nz2)
        write(2)  ((((omg1(i,j,k)),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        write(3)  ((((omg2(i,j,k)),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        write(4)  (((omg3(i,j,k),
     1                i=1,nx1),j=1,ny1),k=1,nz1)


        close(20)
        close(2)
        close(3)
        close(4)  


        endif

	if (time.gt.tstop) goto 202

20	continue

202	continue
       open(2,file='part1.fin')
        nn=nx1/2+1
        do i=1,nx
        xx=(i-1)*dx
          write(2,*) xx,rhog(10,i,2)
        enddo
        close(2)


201	continue
	stop
	end

