        program cylindre

c	versnio de main avec splitting x,y,z du transport/remesh de rho
c	le poussuer/remaille de om et rho sont dissocies

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp1(npm),yp1(npm),zp1(npm),dv1(npm)
        dimension xp2(npm),yp2(npm),zp2(npm)
        dimension omx(npm),omy(npm),omz(npm)
        dimension vx1(npm),vy1(npm),vz1(npm)
        dimension vx2(npm),vy2(npm),vz2(npm)
        dimension strx(npm),stry(npm),strz(npm)
	dimension phip(npm)
c       tableuax supplementaries pour RK
      dimension xp10(npm),yp10(npm),zp10(npm)
      dimension xp20(npm),yp20(npm),zp20(npm)
      dimension om1(npm),om2(npm),om3(npm)
      dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
      dimension vxv1(4,npm),vyv1(4,npm),vzv1(4,npm)
      dimension vxv2(4,npm),vyv2(4,npm),vzv2(4,npm)

      dimension para(4)
      dimension enstrophy(0:10000),energy(0:10000),divergence(0:10000)  

      data (para(i),i=1,4)/0.5,0.5,1.,0./

        character*30 filerho,fileomx,fileomy,fileomz


        pi=3.1415926
        pi2=2.*pi

        OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2
        READ(1,*)
        read(1,*)nit
        READ(1,*)
        read(1,*)anu
        READ(1,*)
        read(1,*)anu_rho
        READ(1,*)
        read(1,*)coef_les
        READ(1,*)
        read(1,*)tstop
        close(1)
        idif=1
		iper=0


        xmin=0.
        ymin=0.
        zmin=0.
        xmax=pi2
        ymax=xmax
        dx1=xmax/float(nx1)
        dx2=xmax/float(nx2)
        zmax=xmax

c	resolution pour rho
c	et initalisation des comptuer utlise pour 
c	avoir des pas de temps distincts en rho et omega

	nx3=32
c	nx3=128
	dx3=xmax/float(nx3)
 
        dy1=dx1
        dz1=dx1
        ny1=nint(float(nx1)*ymax/xmax)
        nz1=nint(float(nx1)*zmax/xmax)
        ymax=float(ny1)*dy1
        zmax=float(nz1)*dz1
        dy2=dx2
        dz2=dx2
        ny2=nint(float(nx2)*ymax/xmax)
        nz2=nint(float(nx2)*zmax/xmax)

	print*, nx1,ny1,nz1,xmax,ymax,zmax


	delt0=1.5*dx1
	delt0=0.003
	delt=delt0
	delt3=delt

	call readfield(npart1,xp1,yp1,zp1,
     1                 omx,omy,omz,dv1)

	print*,'npart1 ',npart1
	call velox
	call veloxaux(vmax,dvmax)
	dvmax=0.
	do k=1,nx3
	kt=mod(k,nx3)+1
	do j=1,nx3
	jt=mod(j,nx3)+1
	do i=1,nx3
	it=mod(i,nx3)+1
	dvmax=amax1(dvmax,abs(psi1(it,j,k)-psi1(i,j,k)))
	dvmax=amax1(dvmax,abs(psi2(i,jt,k)-psi2(i,j,k)))
	dvmax=amax1(dvmax,abs(psi3(i,j,kt)-psi3(i,j,k)))
	enddo
	enddo
	enddo

	print*,' LCFL = ',dvmax*delt3/dx3

c       debut des iterations

	time=0.
	tcompt=0.
	istep=0

        do 20 kk=1,nit
	
	time=time+delt

	circlim=+0.0001
	dt=delt3
c	dt=0.
	np_bl=2
	nx=nx2
	dx=dx2
	call x_advect(dt,np_bl)
	call y_advect(dt,np_bl)
	call z_advect(dt,np_bl)
	
	call dif_rho(anu_rho,dt)
	umax=0.
        do k=1,nx2
        do j=1,nx2
        do i=1,nx2
                umax=amax1(umax,abs(ug(i,j,k)))
                write(24,*) ug(i,j,k)
        enddo
        enddo
        enddo
        close(24)
                print*,'**** TIME et  RHO MAX = ',time,umax


c	Fin de push / remesh rho /dif rho

        if (time.gt.tstop) goto 202

20      continue
202     continue


        write(filerho,140)istep
140     format('rho',i1)

                      open(24,file=filerho)
	umax=0.
            WRITE(24,'(A)') "# vtk DataFile Version 3.0"
        WRITE(24,'(A)') "Scalar"
        WRITE(24,'(A)') "ASCII"
        WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
        WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx2," ",nx2," ",nx2
        WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
        WRITE(24,*) "SPACING"," ",dx," ",dx," ",dx
        WRITE(24,*) "POINT_DATA ",nx2*nx2*nx2
        WRITE(24,'(A)') "SCALARS omg float"
        WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
        do k=1,nx2
        do j=1,nx2
        do i=1,nx2
                umax=amax1(umax,abs(ug(i,j,k)))
                write(24,*) ug(i,j,k)
        enddo
        enddo
        enddo
	close(24)
                print*,'**** RHO MAX = ',umax

	stop
	end

