	subroutine readfield(npart,xp1,yp1,zp1,
     1                 omx,omy,omz,dv1)



        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        real*8 tout(npgx,npgy,npgz,4)
      dimension xp1(*),yp1(*),zp1(*),dv1(*)
      dimension omx(*),omy(*),omz(*)

	pi=3.1415926
	pi2=2.*pi
	circ=0.
	x0=0.
	y0=0.
	z0=0.

      open(2,file='datax',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(3,file='datay',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(4,file='dataz',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(20,file='datarho',form='unformatted',
     1       convert='big_endian',
     1       status='unknown')

        read(2)  ((((omg1(i,j,k)),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        read(3)  ((((omg2(i,j,k)),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        read(4)  (((omg3(i,j,k),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        read(20)  (((ug(i,j,k),
     1                i=1,nx2),j=1,ny2),k=1,nz2)

        close(2)
        close(3)
        close(4)
        close(20)

	npart=0
	rhomax=0.
	do 10 i=1,nx1
        xx=(float(i)-1.)*dx1     
	do 10 j=1,ny1
        yy=(float(j)-1.)*dx1     
	do 10 k=1,nz1
        zz=(float(k)-1.)*dx1     
	aux1=omg1(i,j,k)
	aux2=omg2(i,j,k)
	aux3=omg3(i,j,k)
	if (abs(aux1)+abs(aux2)+abs(aux3).gt.0.0001) then
	npart=npart+1
	xp1(npart)=xx
	yp1(npart)=yy
	zp1(npart)=zz
	dv1(npart)=dx1*dx1*dx1
	omx(npart)=dv1(npart)*aux1
	omy(npart)=dv1(npart)*aux2
	omz(npart)=dv1(npart)*aux3
	circ=circ+omz(npart)
	rhomax=amax1(rhomax,ug(i,j,k))
	endif
10	continue
	print*, 'NPART  ROMAX t=0 =', npart,rhomax

! initailisation des particules de densite et de leurs pentes


	return
	end
