        subroutine remesh_tag(ntag,itag,itype,icfl)


        include 'param.i'
        include 'param.h'
		
		integer itag(*),itype(*),icfl(*)

	dimension ug(npg),up(npg),xp(npg)

	dx2=dh
	dxinv=1./dh

	do i=1,nx
! ug(i)=0.
	enddo

	do n=1,ntag-1,4
! do n=1,1
! reperage des 4 particules taggees: positions, poids 
		i=itag(n)
		ii=itag(n+1)
		iii=itag(n+2)
		iiii=itag(n+3)
		x1m=xp(i)
		x0=xp(ii)
		x1p=xp(iii)
		x2p=xp(iiii)
		u1m=up(i)
		u0=up(ii)
		u1p=up(iii)
		u2p=up(iiii)
! 	u1m=0.
! 	u0=0.
! 	u1p=2.
! 	u2p=0.
	tm=u1m+u0+u1p+u2p
	print*, 'TM avant remshtag', tm
	print*,n,i,x1m,x0,x1p,x2p,u1m,u0,u1p,u2p,itype(i),itype(ii),
     1  itype(iii),itype(iiii)
c
c    reperage du point de base pour les 4 particules taggees selon le type
                if (itype(i).eq.0) then
			ip0 = int((x0-xmin)*dxinv)
			ip1m = int((x1m-xmin)*dxinv)
			ip1p = nint((x1p-xmin)*dxinv)
			ip2p = nint((x2p-xmin)*dxinv)
		else
                        ip0 = nint((x0-xmin)*dxinv)
                        ip1m = nint((x1m-xmin)*dxinv)
                        ip1p = int((x1p-xmin)*dxinv)
                        ip2p = int((x2p-xmin)*dxinv)
    		endif
		xx0 = (x0 - float(ip0)*dx2-xmin)*dxinv
		xx1m = (x1m - float(ip1m)*dx2-xmin)*dxinv
		xx1p = (x1p - float(ip1p)*dx2-xmin)*dxinv
		xx2p = (x2p - float(ip2p)*dx2-xmin)*dxinv
	print*, 'xx1p ',xx1p
! reperage des points de grille concernes
c de I-4 a I+4 ou I est point de grille a gauche de particule x0
	        ip4m=ip0-4
	        ip3m=ip0-3
	        ip2m=ip0-2
	        ip1m=ip0-1
	        ip4p=ip0+4
	        ip3p=ip0+3
	        ip2p=ip0+2
	        ip1p=ip0+1
	        ip0=mod(ip0+nx,nx) +1
	        ip1p=mod(ip1p+nx,nx) +1
	        ip2p=mod(ip2p+nx,nx) +1
	        ip3p=mod(ip3p+nx,nx) +1
	        ip4p=mod(ip4p+nx,nx) +1
	        ip1m=mod(ip1m+nx,nx) +1
	        ip2m=mod(ip2m+nx,nx) +1
	        ip3m=mod(ip3m+nx,nx) +1
	        ip4m=mod(ip4m+nx,nx) +1
c       cases (c) and (d)
c
                if (itype(i).eq.0) then
	coef1m=(xx1m-2.)*(xx1m-1.)*xx1m*(xx1m+1)/24.
	ug(ip4m)=ug(ip4m)+u1m*coef1m
c
	coef1m=-(xx1m-2.)*(xx1m-1.)*xx1m*(xx1m+2)/6.
	coef0=(xx0-2.)*(xx0-1.)*xx0*(xx0+1)/24.
	ug(ip3m)=ug(ip3m)+u1m*coef1m+u0*coef0
c
        coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+1.)*(xx1m+2)/4.
        coef0=-(xx0-2.)*(xx0-1.)*xx0*(xx0+2)/6.
        coef1p=(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
	ug(ip2m)=ug(ip2m)+u1m*coef1m+u0*coef0+u1p*coef1p
c
        coef1m=-(xx1m-2.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/6.
        coef0=(xx0-2.)*(xx0-1.)*(xx0+1.)*(xx0+2)/4.
        coef1p=-(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+3)/6.
        coef2p=(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
       	ug(ip1m)=ug(ip1m)+u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef1m=(xx1m-1.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/24.
	coef1m=coef1m-(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+1)/24.
        coef0=-(xx0-2.)*(xx0-0.)*(xx0+1.)*(xx0+2)/6.
        coef0=coef0+(xx0-3.)*(xx0-1.)*(xx0+0.)*(xx0+1)/6.
        coef0=coef0+(xx0-1.)*(xx0-0.)*(xx0+1.)*(xx0+2)/24.
        coef0=coef0-(xx0-2.)*(xx0-1.)*(xx0+0.)*(xx0+1)/24.
        coef1p=(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+1)/24.
        coef1p=coef1p-(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
        coef1p=coef1p-(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+2)/6.
        coef1p=coef1p+(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+3)/6.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+1)/24.
        coef2p=coef2p-(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
	ug(ip0)=ug(ip0)+u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
	coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+1)/24.
        coef0=-(xx0-3.)*(xx0-1.)*(xx0+0.)*(xx0+1)/6.
        coef1p=(xx1p-2.)*(xx1p-1.)*(xx1p+1.)*(xx1p+2)/4.
        coef2p=-(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+2)/6.
	ug(ip1p)=ug(ip1p)+u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef0=(xx0-2.)*(xx0-1.)*(xx0+0.)*(xx0+1)/24.
        coef1p=-(xx1p-2.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/6.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+1.)*(xx2p+2)/4.
	ug(ip2p)=ug(ip2p)+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef1p=(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
        coef2p=-(xx2p-2.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/6.
	ug(ip3p)=ug(ip3p)+u1p*coef1p+u2p*coef2p
! 
        coef2p=(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
	ug(ip4p)=ug(ip4p)+u2p*coef2p
c
! 	print*, 'REMESH_TAG ',n,i,ii,ip1,jp1
c
! case (c') and (d')
		else
	print*,'c et d',n
c
        coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+1)/24.
        ug(ip3m)=ug(ip3m)+u1m*coef1m
c
        coef1m=-(xx1m-2.)*(xx1m-1.)*(xx1m+0.)*(xx1m+2)/6.
        coef0=(xx0-2.)*(xx0-1.)*xx0*(xx0+1)/24.
        ug(ip2m)=ug(ip2m)+u1m*coef1m+u0*coef0
c
        coef1m=(xx1m-2.)*(xx1m-1.)*(xx1m+1.)*(xx1m+2)/4.
        coef0=-(xx0-2.)*(xx0-1.)*(xx0+0.)*(xx0+2)/6.
        coef1p=(xx1p-3.)*(xx1p-2.)*(xx1p-1.)*(xx1p+0)/24.
        ug(ip1m)=ug(ip1m)+u1m*coef1m+u0*coef0+u1p*coef1p
c
        coef1m=-(xx1m-2.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/6.
        coef1m=coef1m+(xx1m-1.)*(xx1m-0.)*(xx1m+1.)*(xx1m+2)/24.
        coef0=(xx0-2.)*(xx0-1.)*(xx0+1.)*(xx0+2)/4.
        coef0=coef0-(xx0-2.)*(xx0-0.)*(xx0+1.)*(xx0+2)/6.
        coef0=coef0+(xx0-1.)*(xx0-0.)*(xx0+1.)*(xx0+2)/24.
        coef0=coef0+(xx0-1.)*(xx0+1.)*(xx0+2.)*(xx0+3)/6.
        coef1p=(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+1)/24.
        coef1p=coef1p-(xx1p-2.)*(xx1p-1.)*(xx1p+0.)*(xx1p+2)/6.
        coef1p=coef1p+(xx1p-2.)*(xx1p-1.)*(xx1p+1.)*(xx1p+2)/4.
        coef1p=coef1p-(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+1)/24.
        coef2p=coef2p-(xx2p-2.)*(xx2p-1.)*(xx2p+0.)*(xx2p+2)/6.
        ug(ip0)=ug(ip0)+u1m*coef1m+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef0=-(xx0-1.)*(xx0+1.)*(xx0+2.)*(xx0+3)/6.
        coef1p=-(xx1p-2.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/6.
        coef2p=(xx2p-2.)*(xx2p-1.)*(xx2p+1.)*(xx2p+2)/4.
      ug(ip1p)=ug(ip1p)+u0*coef0+u1p*coef1p+u2p*coef2p
c
        coef1p=(xx1p-1.)*(xx1p-0.)*(xx1p+1.)*(xx1p+2)/24.
        coef2p=-(xx2p-2.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/6.
      ug(ip2p)=ug(ip2p)+u1p*coef1p+u2p*coef2p

        coef2p=(xx2p-1.)*(xx2p-0.)*(xx2p+1.)*(xx2p+2)/24.
      ug(ip3p)=ug(ip3p)+u2p*coef2p
c
		endif
	enddo
	
		return
		end
	

