        subroutine remeshy(np1,xp1,up1,itype,jj,kk)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	dimension xp1(*),up1(*),itype(*)



! remaillage des particules fluides

	dxinv=1./dx2

	do i=1,nx2
	ug(jj,i,kk)=0.
	enddo

         x0=xmin

         do n = 1,np1
            g1 = up1(n)
            x = xp1(n)
			
			if (itype(n).eq.0) then
            ip1 = int((x-x0)*dxinv)
		else
            ip1 = nint((x-x0)*dxinv)
		endif
	    ip0 = ip1 - 1
            ip2 = ip1 + 1
            ip3 = ip1 - 2
            ip4 = ip1 + 2



           xx1 = (x - float(ip1)*dx2-x0)*dxinv
           xx0=xx1+1.
           xx2=xx1-1.
           xx3=xx1+2.
           xx4=xx1-2.

        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
        ip3=mod(ip3+nx2,nx2) +1
        ip4=mod(ip4+nx2,nx2) +1
c
c     Lambda4:
c
          a0 = -xx4*xx2*xx1*xx3/6.
          a1 = xx0*xx2*xx3*xx4/4.
          a2 = -xx0*xx1*xx3*xx4/6.
          a3 = xx0*xx1*xx2*xx4/24.
          a4 = xx0*xx1*xx2*xx3/24.

           ug(jj,ip0,kk) = ug(jj,ip0,kk) + g1*a0
           ug(jj,ip1,kk) = ug(jj,ip1,kk) + g1*a1
           ug(jj,ip2,kk) = ug(jj,ip2,kk) + g1*a2
           ug(jj,ip3,kk) = ug(jj,ip3,kk) + g1*a3
           ug(jj,ip4,kk) = ug(jj,ip4,kk) + g1*a4
		   
	enddo

	go to 222
	do k=3,nx2-2
	do j=1,nx2
	do i=1,nx2
	if (ug(i,j,k).gt.1.2) then
	print*,'BOUM', i,j,k,ug(i,j,k)
	goto 222
	endif
	enddo
	enddo
	enddo

222	continue
        RETURN
        END



