        subroutine remeshz(np1,xp1,up1,itype,jj,kk)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	dimension xp1(*),up1(*),itype(*)



! remaillage des particules fluides

	dxinv=1./dx2

	do i=1,nx2
	ug(jj,kk,i)=0.
	enddo

         x0=xmin

         do n = 1,np1
            g1 = up1(n)
            x = xp1(n)
			
			if (itype(n).eq.0) then

            ip1 = int((x-x0)*dxinv)
            ip0 = ip1 - 1
            ip2 = ip1 + 1

! print*, ' IPO ..',n,xp1(n),ip0,ip1,ip2

           xx1 = (x - float(ip1)*dx2-x0)*dxinv
           xx0=xx1+1
           xx2=1-xx1

        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
c
c     left-Lambda2:
c
        a0=-0.5*xx1*xx2
        a1=1.-xx1**2
        a2=0.5*xx0*xx1

           ug(jj,kk,ip0) = ug(jj,kk,ip0) + g1*a0
           ug(jj,kk,ip1) = ug(jj,kk,ip1) + g1*a1
           ug(jj,kk,ip2) = ug(jj,kk,ip2) + g1*a2
		   
		   else
		   
		    ip1 = nint((x-x0)*dxinv)
            ip0 = ip1 - 1
            ip2 = ip1 + 1

           xx1 = (x - float(ip1)*dx2-x0)*dxinv
           xx0=xx1+1
           xx2=1-xx1

        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
c
c     center-Lambda2:
c
        a0=-0.5*xx1*xx2
        a1=1.-xx1**2
        a2=0.5*xx0*xx1

           ug(jj,kk,ip0) = ug(jj,kk,ip0) + g1*a0
           ug(jj,kk,ip1) = ug(jj,kk,ip1) + g1*a1
           ug(jj,kk,ip2) = ug(jj,kk,ip2) + g1*a2
		   
		   endif
	enddo

        RETURN
        END



