        subroutine remeshz(np1,xp1,up1,itype,jj,kk,sl1,sl2)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp1(*),up1(*),itype(*),sl1(*),sl2(*)

! remaillage des particules fluides

	dxinv=1./dx2

	do i=1,nx2
	ug(jj,kk,i)=0.
	enddo

         x0=xmin

         do n = 1,np1
            g1 = up1(n)
            x = xp1(n)
			
            ip1 = int((x-x0)*dxinv)
        if (itype(n).eq.1) ip1 = nint((x-x0)*dxinv)
            ip0 = ip1 - 1
            ip2 = ip1 + 1

           xx1 = (x - float(ip1)*dx2-x0)*dxinv
           xx0=xx1+1
           xx2=1-xx1

        ip1=mod(ip1+nx2,nx2) +1
        ip0=mod(ip0+nx2,nx2) +1
        ip2=mod(ip2+nx2,nx2) +1
c
c     Lambda2:
c
c       avec les pentes:

        a0=0.5*((xx1-0.5)**2)-sl2(n)/8.
        a1=0.75-xx1**2+(sl1(n)+sl2(n))/8.
        a2=0.5*((xx1+0.5)**2)-sl1(n)/8.

           ug(jj,kk,ip0) = ug(jj,kk,ip0) + g1*a0
           ug(jj,kk,ip1) = ug(jj,kk,ip1) + g1*a1
           ug(jj,kk,ip2) = ug(jj,kk,ip2) + g1*a2
		   
	enddo

        RETURN
        END



