	program spec


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension aux3(npgx,npgy,npgz),
     1             aux1(npgx,npgy,npgz),aux2(npgx,npgy,npgz)

	parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

	complex cfx,cfy,cfz,cux,cuy,cuz,wk
	common/fft/cux(1-ngx2:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuy(1-ngx2:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuz(1-ngx2:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfx(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz)
      real ijc(1-ngx2:ngx2,1-ngx2:ngx2,1-ngx2:ngx2)
      real nrj(ngx2)



        pi=3.1415926
        pi2=2*pi

       OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2

        xmin=0.
        ymin=0.
        zmin=0.
        xmax=pi2
        ymax=pi2
        zmax=pi2

	ny1=nx1
	nz1=nx1

c	calucl de fonction courants 3d

	nxb=nx1/2
	nyb=ny1/2
	nzb=nz1/2

       open(11,FILE='omx',
     1        FORM='unformatted', convert='big_endian',
     1        status='old')
       read(11) (((omg1(i,j,k),i=1,nx1),j=1,ny1),k=1,nz1)
       close(11)

       open(12,FILE='omy',
     1        FORM='unformatted', convert='big_endian',
     1        status='old')
       read(12) (((omg2(i,j,k),i=1,nx1),j=1,ny1),k=1,nz1)
       close(12)

       open(13,FILE='omz',
     1        FORM='unformatted', convert='big_endian',
     1        status='old')
       read(13) (((omg3(i,j,k),i=1,nx1),j=1,ny1),k=1,nz1)
      close(13)

	print*,'hello'

      call fftw3d(omg1,cfx,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)
      call fftw3d(omg2,cfy,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)
      call fftw3d(omg3,cfz,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)

	print*,'hello'

c 	coeff de normalisation pour laplacien en spectral


	ai=2.*pi/(xmax-xmin)	
	aj=2.*pi/(ymax-ymin)	
	ak=2.*pi/(zmax-zmin)	
	
	ai2=ai**2
	aj2=aj**2
	ak2=ak**2

      do 10 k=1-nzb,nzb
         rk=float(k)*ak
         do 10 j=1-nyb,nyb
            rj=float(j)*aj
            do 10 i=0,nxb
               ri=float(i)*ai
	       r2=ri**2+rj**2+rk**2
	cux(i,j,k)=cmplx(0.0,0.0)
	cuy(i,j,k)=cmplx(0.0,0.0) 
	cuz(i,j,k)=cmplx(0.0,0.0) 
	if (r2.ne.0.) then
c
      cux(i,j,k)=cmplx(0.0,1.0)*(-rj*cfz(i,j,k)+rk*cfy(i,j,k))/r2
      cuy(i,j,k)=cmplx(0.0,1.0)*(-rk*cfx(i,j,k)+ri*cfz(i,j,k))/r2
      cuz(i,j,k)=cmplx(0.0,1.0)*(-ri*cfy(i,j,k)+rj*cfx(i,j,k))/r2
        endif
10    continue   


         do k=1-nzb,nzb
         do j=1-nyb,nyb
         do i=1,nxb
          if (i.le.nxb-1) cux(-i,j,k)=cux(i,j,k)
          if (i.le.nxb-1) cuy(-i,j,k)=cuy(i,j,k)
          if (i.le.nxb-1) cuz(-i,j,k)=cuz(i,j,k)
         enddo
         enddo
         enddo
c
        open(1,file='spectre_en')
        do l=1,nxb
c
         do k=1-nzb,nzb
         do j=1-nyb,nyb
         do i=1-nxb,nxb
         ijc(i,j,k)=float(i**2+j**2+k**2)
         xmod=sqrt(ijc(i,j,k))
         if ((xmod.lt.l+0.5).and.(xmod.ge.l-0.5)) then
         z=cabs(cux(i,j,k))**2+cabs(cuy(i,j,k))**2+cabs(cuz(i,j,k))**2
         s=s+z
         endif
         enddo
         enddo
         enddo
c
        nrj(l)=s
c
        write(1,*)l,nrj(l)/2
        s=0.
        enddo
        close(1)
c



	stop
	end

