	subroutine stretch_freeb(drho)

! terme de stretching 3D sur grille + forcing du a densite variable
! dans approx de Bouss.
! gravite orientee selon axe des x
! la densite est recuperee du scalaire ug


        include 'param.i'
        include 'param.h'
        include 'arrays.h'
                                      
        dy1=dx1
        dz1=dx1

        dxinv=1./(12.*dx1)
        dyinv=1./(12.*dy1)
        dzinv=1./(12.*dz1)     

        do k=1,nz1
        kt=mod(k+nz1,nz1)+1
        kb=mod(k-2+nz1,nz1)+1
        ktt=mod(k+1+nz1,nz1)+1
        kbb=mod(k-3+nz1,nz1)+1
cc
        do j=1,ny1
        jt=mod(j+ny1,ny1)+1
        jb=mod(j-2+ny1,ny1)+1
        jtt=mod(j+1+ny1,ny1)+1
        jbb=mod(j-3+ny1,ny1)+1
cc
        do i=1,nx1
        it=mod(i+nx1,nx1)+1
        ib=mod(i-2+nx1,nx1)+1
        itt=mod(i+1+nx1,nx1)+1
        ibb=mod(i-3+nx1,nx1)+1
                               
c
        aux1=omg1(itt,j,k)*vxg(itt,j,k)+8.*(omg1(ib,j,k)*vxg(ib,j,k)-
     1          omg1(it,j,k)*vxg(it,j,k))-omg1(ibb,j,k)*vxg(ibb,j,k)
        aux2=omg2(i,jtt,k)*vxg(i,jtt,k)+8.*(omg2(i,jb,k)*vxg(i,jb,k)-
     1          omg2(i,jt,k)*vxg(i,jt,k))-omg2(i,jbb,k)*vxg(i,jbb,k)
	aux3=omg3(i,j,ktt)*vxg(i,j,ktt)+8.*(omg3(i,j,kb)*vxg(i,j,kb)-
     1          omg3(i,j,kt)*vxg(i,j,kt))-omg3(i,j,kbb)*vxg(i,j,kbb)

	strg1(i,j,k)=-aux1*dxinv-aux2*dyinv-aux3*dzinv
c
        aux1=omg1(itt,j,k)*vyg(itt,j,k)+8.*(omg1(ib,j,k)*vyg(ib,j,k)-
     1          omg1(it,j,k)*vyg(it,j,k))-omg1(ibb,j,k)*vyg(ibb,j,k)
        aux2=omg2(i,jtt,k)*vyg(i,jtt,k)+8.*(omg2(i,jb,k)*vyg(i,jb,k)-
     1          omg2(i,jt,k)*vyg(i,jt,k))-omg2(i,jbb,k)*vyg(i,jbb,k)
	aux3=omg3(i,j,ktt)*vyg(i,j,ktt)+8.*(omg3(i,j,kb)*vyg(i,j,kb)-
     1          omg3(i,j,kt)*vyg(i,j,kt))-omg3(i,j,kbb)*vyg(i,j,kbb)

	strg2(i,j,k)=-aux1*dxinv-aux2*dyinv-aux3*dzinv    
! terme venant de densite varaible
	aux=ug(i,j,ktt)+8*(ug(i,j,kb)-ug(i,j,kt))-ug(i,j,kbb)
	strg2(i,j,k)=strg2(i,j,k)-drho*aux*dzinv
! 
        aux1=omg1(itt,j,k)*vzg(itt,j,k)+8.*(omg1(ib,j,k)*vzg(ib,j,k)-
     1          omg1(it,j,k)*vzg(it,j,k))-omg1(ibb,j,k)*vzg(ibb,j,k)
        aux2=omg2(i,jtt,k)*vzg(i,jtt,k)+8.*(omg2(i,jb,k)*vzg(i,jb,k)-
     1          omg2(i,jt,k)*vzg(i,jt,k))-omg2(i,jbb,k)*vzg(i,jbb,k)
	aux3=omg3(i,j,ktt)*vzg(i,j,ktt)+8.*(omg3(i,j,kb)*vzg(i,j,kb)-
     1          omg3(i,j,kt)*vzg(i,j,kt))-omg3(i,j,kbb)*vzg(i,j,kbb)

	strg3(i,j,k)=-aux1*dxinv-aux2*dyinv-aux3*dzinv    
! terme venant de densite varaible
	aux=ug(i,jtt,k)+8*(ug(i,jb,k)-ug(i,jt,k))-ug(i,jbb,k)
	strg3(i,j,k)=strg3(i,j,k)+drho*aux*dyinv

	enddo
	enddo
	enddo

	return
	end
