	subroutine velox_burgers(vxmax,dvmax)

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

	complex cfx,cux,cvx,wk,wk2
	dimension cux(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz),
     1             wk2(ngx2+1,npgy,npgz)

        dimension aux2(npgx,npgy,npgz)

        pi=3.1415926

c	Fourier

	nxb=nx1/2
	nyb=ny1/2
	nzb=nz1/2

        nxb2=nx3/2
        nyb2=nx3/2
        nzb2=nx3/2
        dx3=(xmax-xmin)/float(nx3)

      call fftw3d(ug,cux,nx1,ny1,nz1,nxb,nyb,nzb,wk,0)

c	filtre 	lineaire
	
      do 10 k=1-nzb,nzb
         do 10 j=1-nyb,nyb
            do 10 i=1,nxb
	xi=(sin(8.*pi*i*dx3)/(8.*pi*i*dx3))**2
      cux(i,j,k)=cux(i,j,k)*xi
10    continue

c	retour ds l'espace physique

      call fftw3d(aux2,cux,nx1,ny1,nz1,nxb,nyb,nzb,wk2,1)

	vxmax=0.
	dvmax=0.
        do k=1,nx3
        do j=1,nx3
        do i=1,nx3
        psi1(i,j,k)=aux2(i,j,k)
	vxmax=amax1(vxmax,abs(psi1(i,j,k)))
        enddo
        enddo
        enddo
	print*,' VXMAX sur grille ',vxmax

        do k=1,nx3
        do j=1,nx3
        do i=1,nx3
        it=mod(i,nx3)+1
        dvmax=amax1(dvmax,abs(psi1(it,j,k)-psi1(i,j,k)))
        enddo
        enddo
        enddo

	do i=1,nx3
c	print*, psi1(1,i,1),psi1(i,2,2),psi1(i,128,128)
	enddo
	return
	end

