	subroutine y_advect(dt,np_bl,ntag_total)
	
        include 'param.i'
        include 'param.h'
        include 'arrays.h'

		integer icfl(npg),itype(npg),itype_aux(npg),itag(npg)
		dimension xp_aux(npg),up_aux(npg),vx_aux(npg)

        dimension sl(npg),sl1(npg),sl2(npg)

! cfl=dt/dx utilisse pour calculs de blocs et correction
	cfl=dt/dx

        ntag_total=0
	      		
! on balaie le lignes verticales

	do k=1,nx
		zz=xmin+float(k-1)*dx
	do i=1,nx
		np=0
		yy=xmin+float(i-1)*dx
		do j=1,nx
! initiliasation particules sur la ligne j
		if (abs(ug(i,j,k)).gt.circlim) then
		np=np+1
		up(np)=ug(i,j,k)
		xp(np)=xmin+float(j-1)*dx
		endif
		enddo
!  tag, push and remesh sur la ligne
		if (np.ne.0) then

! evaluation des vitesse pour RK2

		call velox_y(np,i,k)
		do n=1,np
		xp0(n)=xp(n)
		xp(n)=xp(n)+0.5*dt*vx(n)
		if (xp(n).gt.xmax) xp(n)=xp(n)-xmax+xmin
                if (xp(n).lt.xmin) xp(n)=xp(n)+xmax-xmin
		enddo
		call velox_y(np,i,k)
c       pentes pour limiteurs

                call slopes(dt,np,sl)
	
		call tag_particles(np,np_aux,ntag,np_bl,
	1   icfl,itype,itype_aux,itag,
	1	xp_aux,up_aux,vx_aux,sl,sl1,sl2)

	
		if (ntag.ne.0) then
		do n=1,ntag
			ii=itag(n)
			xp(ii)=xp0(ii)+dt*vx(ii)
			if (xp(ii).gt.xmax) xp(ii)=xp(ii)-xmax+xmin
                        if (xp(ii).lt.xmin) xp(ii)=xp(ii)+xmax-xmin
		enddo
		endif
	
		do n=1,np_aux
		xp_aux(n)=xp_aux(n)+dt*vx_aux(n)
	    if (xp_aux(n).gt.xmax) xp_aux(n)=xp_aux(n)-xmax+xmin
            if (xp_aux(n).lt.xmin) xp_aux(n)=xp_aux(n)+xmax-xmin
		enddo
		ir=i
		kr=k
	call remeshy(np_aux,xp_aux,up_aux,itype_aux,ir,kr,sl1,sl2)
	if (ntag.ne.0) call remeshy_tag(ntag,itag,itype,icfl,ir,kr,sl)
	
! fin de ligne i :
        ntag_total=ntag_total+ntag
		endif
	enddo
	enddo
        print*, ' NTAG apres y advect ', ntag_total

	
	return
	end
