C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SUBROUTINE  dif_om(npart,om1,om2,om3,
     1              xp1,yp1,zp1,dv1,anu,delt,coef_les,omax1)



C
C   This subroutine asssigns vorticity on a grid
C

c----------------------------------------------------------------

	include 'param.i'
	include 'param.h'
	include 'arrays.h'



	dimension xp1(*),yp1(*),zp1(*),dv1(*)
	dimension om1(*),om2(*),om3(*)
        dimension dom1(npm),dom2(npm),dom3(npm)
	integer indx(npm),indy(npm),indz(npm)



        dxinv=1./(dx1)
	dy1=dx1
	dz1=dx1
        dyinv=dxinv
        dzinv=dxinv

	npart=0
	vol=dx1**3

	do k=1,nz1
	z=zmin+(k-1)*dz1
	do j=1,ny1
	y=ymin+(j-1)*dy1
	do i=1,nx1
	x=xmin+(i-1)*dx1
        strength=abs(omg2(i,j,k))+abs(omg1(i,j,k))+abs(omg3(i,j,k))
	if ((strength.gt.circlim)) then
        npart=npart+1
        indx(npart)=i
        indy(npart)=j
        indz(npart)=k
        xp1(npart)=x
        yp1(npart)=y
        zp1(npart)=z
        dv1(npart)=dx1**3
	om1(npart)=omg1(i,j,k)*vol
	om2(npart)=omg2(i,j,k)*vol
	om3(npart)=omg3(i,j,k)*vol
	endif
	enddo
	enddo
	enddo

! goto 1001

        dzdx=(dz1/dx1)**2
        dzdy=(dz1/dy1)**2
        trace=dzdx+dzdy+1.

        alpha=3.333333
        beta=5.666667
        alambda=2./(beta-alpha)
        amu=-2.*alpha/((beta-alpha)*(2.*alpha+beta))

c       boucle sur les receveurs


        tot=0.

        do i=1,npart
        dom1(i)=0.
        dom2(i)=0.
        dom3(i)=0.
        tot2=0.

        ii=indx(i)
        jj=indy(i)
        kk=indz(i)
        gammarcv1=om1(i)
        gammarcv2=om2(i)
        gammarcv3=om3(i)
        vxrcv=vxg(ii,jj,kk)
        vyrcv=vyg(ii,jj,kk)
        vzrcv=vzg(ii,jj,kk)

c       boucle sur les 27 sources
           do lx=-1,1
           do ly=-1,1
           do lz=-1,1
        i2=mod(ii+lx+nx1-1,nx1)+1
        j2=mod(jj+ly+ny1-1,ny1)+1
        k2=mod(kk+lz+nz1-1,nz1)+1
           gammasrc1=omg1(i2,j2,k2)*vol
           gammasrc2=omg2(i2,j2,k2)*vol
           gammasrc3=omg3(i2,j2,k2)*vol
           vxsrc=vxg(i2,j2,k2)
           vysrc=vyg(i2,j2,k2)
           vzsrc=vzg(i2,j2,k2)
           dvx=(vxsrc-vxrcv)/dx1
           dvy=(vysrc-vyrcv)/dy1
           dvz=(vzsrc-vzrcv)/dz1
           r=lx**2+ly**2+lz**2
        am1=alambda*dzdx+amu*trace
        am2=alambda*dzdy+amu*trace
        am3=alambda+amu*trace
        ales=amax1(0.,-dvx*lx-dvy*ly-dvz*lz)
c        ales=abs(dvx*lx+dvy*ly+dvz*lz)
        akernel=((lx**2)*am1+(ly**2)*am2+(lz**2)*am3)/(1.+r)
        akernel2=2.5/((1.+r)*2.8333)
        factor=akernel/(dz1*dz1)
        dom1(i)=dom1(i)+(gammasrc1-gammarcv1)*
     1                  (anu*factor+coef_les*ales*akernel2)
        dom2(i)=dom2(i)+(gammasrc2-gammarcv2)*
     1                  (anu*factor+coef_les*ales*akernel2)
        dom3(i)=dom3(i)+(gammasrc3-gammarcv3)*
     1                  (anu*factor+coef_les*ales*akernel2)

        enddo
        enddo
        enddo
        tot=amax1(tot,tot2*dy1*dx1*dz1/dv1(i))

c       enddo pour caluc de dom sur les particules
        enddo

1001	continue

        omax0=0.
        omax1=0.

        do i=1,npart
        omax0=amax1(omax0,abs(om1(i))/dv1(i))
       omax0=amax1(omax0,abs(om2(i))/dv1(i))
       omax0=amax1(omax0,abs(om3(i))/dv1(i))
        om1(i)=om1(i)+delt*dom1(i)
        om2(i)=om2(i)+delt*dom2(i)
        om3(i)=om3(i)+delt*dom3(i)
       omax1=amax1(omax1,abs(om1(i))/dv1(i))
       omax1=amax1(omax1,abs(om2(i))/dv1(i))
       omax1=amax1(omax1,abs(om3(i))/dv1(i))
        enddo

        print*, 'OMAX avant et apres diff ', omax0,omax1
        if (omax1.gt.omax0) print*, '****** ATTENTION DIFFUSION'

310     continue

	RETURN
	END
