C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SUBROUTINE  dif_rho(anu,dt)


C
C   This subroutine asssigns vorticity on a grid
C

c----------------------------------------------------------------

	include 'param.i'
	include 'param.h'
	include 'arrays.h'

	anudt=anu*dt/(dx2**2)

	rhomax1=0.
	rhomax2=0.

	do k=1,nz2
	kt=mod(k,nz2)+1
	kb=mod(k-2+nz2,nz2)+1
	do j=1,ny2
	jt=mod(j,nz2)+1
	jb=mod(j-2+nz2,nz2)+1
	do i=1,nx2
	it=mod(i,nz2)+1
	ib=mod(i-2+nz2,nz2)+1
	drho=ug(it,j,k)+ug(ib,j,k)+ug(i,jt,k)+ug(i,jb,k)+ug(i,j,kt)+ug(i,j,kb)
	drho=drho-6.*ug(i,j,k)
	rhomax1=amax1(rhomax1,abs(ug(i,j,k)))
	ug(i,j,k)=ug(i,j,k)+anudt*drho
	rhomax2=amax1(rhomax2,abs(ug(i,j,k)))
	enddo
	enddo
	enddo

	print*, 'RHOMAX avant et apres DIFF ',rhomax1,rhomax2
	return
	end
