	subroutine pen(coef_pen,omx,omy,omz,delt)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	dimension domg(npg,npg,npg)
	dimension omx(*),omy(*),omz(*)
                                           
c	condition limite v=vh par penalisation implicite en vorticite

	pi=3.1415926
	topi=2./pi
	spi=sqrt(pi)

	eps=float(nc)*dx
	eps=dx/1000.
	eps2=eps**2

        dxinv=1./(2.*dx)
        dyinv=1./(2.*dy)                                               

	cdelt=coef_pen*delt


c	penalisation sous forme : 
c	omega_n+1=curl[(u_n+coef_pen*delt*vh)/(1+coef_pen)]

	npart=0
        do k=1,nz
        kt=mod(k+nz,nz)+1
        kb=mod(k-2+nz,nz)+1
        do j=1,ny
        jt=mod(j+ny,ny)+1
        jb=mod(j-2+ny,ny)+1
        do i=1,nx
	npart=npart+1
	strg1(i,j)=0.
	strg3(i,j)=0.
	strg3(i,j)=0.
        it=mod(i+nx,nx)+1
        ib=mod(i-2+nx,nx)+1
        arg=phig(i,j,k)
        argt=phig(i,jt,k)
        argb=phig(i,jb,k)
        argu=phig(i,j,kt)
        argd=phig(i,j,kb)
        argr=phig(it,j,k)
        argl=phig(ib,j,k)

c	x-component:
	term1=(vzg(i,jt,k)+argt*cdelt*vzh)/(1.+cdelt*argt)
	term2=(vzg(i,jb,k)+argb*cdelt*vzh)/(1.+cdelt*argb)
	domg(i,j,k)=(term1-term2)/(2.*dx)-omg1(i,j,k)
	term1=(vyg(i,j,kt)+argu*cdelt*vyh)/(1.+cdelt*argu)
	term2=(vyg(i,j,kb)+argd*cdelt*vyh)/(1.+cdelt*argd)
	domg(i,j,k)=domg(i,j,k)-(term1-term2)/(2.*dx)
	omx(npart)=omx(npart)+(dx**2)*domg(i,j,k)

c	y-component:
	term1=(vxg(i,j,kt)+argu*cdelt*vxh)/(1.+cdelt*argu)
	term2=(vxg(i,j,kb)+argd*cdelt*vxh)/(1.+cdelt*argd)
	domg(i,j,k)=(term1-term2)/(2.*dx)-omg2(i,j,k)
	term1=(vzg(it,j,k)+argr*cdelt*vzh)/(1.+cdelt*argr)
	term2=(vzg(ib,j,k)+argl*cdelt*vzh)/(1.+cdelt*argl)
	omy(npart)=omy(npart)+(dx**2)*domg(i,j,k)

c	z-component:
	term1=(vyg(it,j,k)+argu*cdelt*vyh)/(1.+cdelt*argr)
	term2=(vyg(ib,j,k)+argd*cdelt*vyh)/(1.+cdelt*argl)
	domg(i,j,k)=(term1-term2)/(2.*dx)-omg3(i,j,k)
	term1=(vxg(i,jt,k)+argr*cdelt*vxh)/(1.+cdelt*argt)
	term2=(vxg(i,jb,k)+argl*cdelt*vxh)/(1.+cdelt*argb)
	omz(npart)=omz(npart)+(dx**2)*domg(i,j,k)

	enddo
	enddo
	enddo

	

111	continue

	return
	end
