	subroutine velox_stream


        include 'param.i'
        include 'param.h'
        include 'arrays.h'


	integer indxg(npgx,npgy),indyg(npgx,npgy)
                                           


        dxinv2=0.5/dx
        dyinv2=0.5/dy
        dzinv2=0.5/dz

	vnmax=0.
	vxmin=1000.
	vxmax=-1000.
	vymin=100.
	vymax=-1000.
	do k=1,nz
	kt=mod(k,nz)+1
        kb=mod(k-2+nz,nz)+1
        do j=1,ny
        jt=mod(j,ny)+1
        jb=mod(j-2+ny,ny)+1
        do i=1,nx
        it=mod(i,nx)+1
        ib=mod(i-2+nx,nx)+1
        vxg(i,j,k)=(-psi3(i,jb,k)+psi3(i,jt,k))*dyinv2-
     1             (-psi2(i,j,kb)+psi2(i,j,kt))*dzinv2 

        vyg(i,j,k)=(-psi1(i,j,kb)+psi1(i,j,kt))*dzinv2-
     1             (-psi3(ib,j,k)+psi3(it,j,k))*dxinv2    

        vzg(i,j,k)=(-psi2(ib,j,k)+psi2(it,j,k))*dxinv2-
     1             (-psi1(i,jb,k)+psi1(i,jt,k))*dyinv2    

        vymax=amax1(vymax,(vyg(i,j,k)))
        vymin=amin1(vymin,(vyg(i,j,k)))
        vxmax=amax1(vxmax,(vxg(i,j,k)))
        vxmin=amin1(vxmin,(vxg(i,j,k)))
	enddo
	enddo
	enddo

c	print*,' VXMAX = ',vxmax,vymax


	return
	end
