!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        SUBROUTINE  dif_om(npart,om1,om2,om3,xp1,yp1,zp1,dv1,anu,dt,omax2)

        dimension xp1(*),yp1(*),zp1(*),dv1(*)
        dimension om1(*),om2(*),om3(*)
!
!   diffusion sur grille puis initialisation des particules
!

!----------------------------------------------------------------

	include 'param.i'
	include 'param.h'
	include 'arrays.h'

	anudt=anu*dt/(dx**2)

	circlim=0.001

	omax1=0.
	omax2=0.

	do k=1,nz
	kt=mod(k,nz)+1
	kb=mod(k-2+nz,nz)+1
	do j=1,ny
	jt=mod(j,nz)+1
	jb=mod(j-2+nz,nz)+1
	do i=1,nx
	it=mod(i,nz)+1
	ib=mod(i-2+nz,nz)+1
	psi1(i,j,k)=omg1(it,j,k)+omg1(ib,j,k)+omg1(i,jt,k)+omg1(i,jb,k)+omg1(i,j,kt)+omg1(i,j,kb)-6.*omg1(i,j,k)
	psi2(i,j,k)=omg2(it,j,k)+omg2(ib,j,k)+omg2(i,jt,k)+omg2(i,jb,k)+omg2(i,j,kt)+omg2(i,j,kb)-6.*omg2(i,j,k)
	psi3(i,j,k)=omg3(it,j,k)+omg3(ib,j,k)+omg3(i,jt,k)+omg3(i,jb,k)+omg3(i,j,kt)+omg3(i,j,kb)-6.*omg3(i,j,k)
	omax1=amax1(omax1,abs(omg1(i,j,k)))
	omax1=amax1(omax1,abs(omg2(i,j,k)))
	omax1=amax1(omax1,abs(omg3(i,j,k)))
	enddo
	enddo
	enddo

	npart=0
	vol=dx**3
        do k=1,nz
        z=zmin+(k-1)*dz
        do j=1,ny
        y=ymin+(j-1)*dy
        do i=1,nx
        x=xmin+(i-1)*dx
	omg1(i,j,k)=omg1(i,j,k)+anudt*psi1(i,j,k)
	omg2(i,j,k)=omg2(i,j,k)+anudt*psi2(i,j,k)
	omg3(i,j,k)=omg3(i,j,k)+anudt*psi3(i,j,k)
	strength=abs(omg2(i,j,k))+abs(omg1(i,j,k))+abs(omg3(i,j,k))
        if ((strength.gt.circlim)) then
        npart=npart+1
        xp1(npart)=x
        yp1(npart)=y
        zp1(npart)=z
        dv1(npart)=dx**3
        om1(npart)=omg1(i,j,k)*vol
        om2(npart)=omg2(i,j,k)*vol
        om3(npart)=omg3(i,j,k)*vol
	endif
	omax2=amax1(omax2,abs(omg1(i,j,k)))
	omax2=amax1(omax2,abs(omg2(i,j,k)))
	omax2=amax1(omax2,abs(omg3(i,j,k)))
	enddo
	enddo
	enddo

	print*, 'OMAX avant et apres DIFF ',omax1,omax2
	return
	end
