	subroutine pen(coef_pen,delt)


        include 'param.i'
        include 'param.h'
        include 'arrays.h'

!condition limite v=vh par penalisation implicite en vorticite

	cdelt=coef_pen*delt

	vxh=0.
	vyh=0.
	vzh=0.

!penalisation sous forme : 
!omega_n+1=curl[(u_n+coef_pen*delt*vh)/(1+coef_pen)]

        do k=1,nz
        kt=mod(k+nz,nz)+1
        kb=mod(k-2+nz,nz)+1
        do j=1,ny
        jt=mod(j+ny,ny)+1
        jb=mod(j-2+ny,ny)+1
        do i=1,nx
        it=mod(i+nx,nx)+1
        ib=mod(i-2+nx,nx)+1
        arg=phig(i,j,k)
        argt=phig(i,jt,k)
        argb=phig(i,jb,k)
        argu=phig(i,j,kt)
        argd=phig(i,j,kb)
        argr=phig(it,j,k)
        argl=phig(ib,j,k)

!x-component:
	term1=(vzg(i,jt,k)+argt*cdelt*vzh)/(1.+cdelt*argt)
	term2=(vzg(i,jb,k)+argb*cdelt*vzh)/(1.+cdelt*argb)
	omg1(i,j,k)=(term1-term2)/(2.*dx)
	term1=(vyg(i,j,kt)+argu*cdelt*vyh)/(1.+cdelt*argu)
	term2=(vyg(i,j,kb)+argd*cdelt*vyh)/(1.+cdelt*argd)
	omg1(i,j,k)=omg1(i,j,k)-(term1-term2)/(2.*dx)

!y-component:
	term1=(vxg(i,j,kt)+argu*cdelt*vxh)/(1.+cdelt*argu)
	term2=(vxg(i,j,kb)+argd*cdelt*vxh)/(1.+cdelt*argd)
	omg2(i,j,k)=(term1-term2)/(2.*dx)
	term1=(vzg(it,j,k)+argr*cdelt*vzh)/(1.+cdelt*argr)
	term2=(vzg(ib,j,k)+argl*cdelt*vzh)/(1.+cdelt*argl)
	omg2(i,j,k)=omg2(i,j,k)-(term1-term2)/(2.*dx)

!z-component:
	term1=(vyg(it,j,k)+argu*cdelt*vyh)/(1.+cdelt*argr)
	term2=(vyg(ib,j,k)+argd*cdelt*vyh)/(1.+cdelt*argl)
	omg3(i,j,k)=(term1-term2)/(2.*dx)
	term1=(vxg(i,jt,k)+argr*cdelt*vxh)/(1.+cdelt*argt)
	term2=(vxg(i,jb,k)+argl*cdelt*vxh)/(1.+cdelt*argb)
	omg3(i,j,k)=omg3(i,j,k)-(term1-term2)/(2.*dx)

111	continue
	enddo
	enddo
	enddo

	


	return
	end
