        subroutine remeshy(np1,xp1,up1,itype,jj,kk)


        include 'param.i'
        include 'param.h'

	dimension xp1(*),up1(*),itype(*)



c	remaillage des particules fluides

	dxinv=1./dx

	do i=1,nx
	ug(jj,i,kk)=0.
	enddo

         x0=xmin

         do n = 1,np1
            g1 = up1(n)
            x = xp1(n)
			
			if (itype(n).eq.0) then

            ip1 = int((x-x0)*dxinv)
            ip0 = ip1 - 1
            ip2 = ip1 + 1

c	print*, ' IPO ..',n,xp1(n),ip0,ip1,ip2

           xx1 = (x - float(ip1)*dx-x0)*dxinv
           xx0=xx1+1
           xx2=1-xx1

        ip1=mod(ip1+nx,nx) +1
        ip0=mod(ip0+nx,nx) +1
        ip2=mod(ip2+nx,nx) +1
c
c     left-Lambda2:
c
        a0=-0.5*xx1*xx2
        a1=1.-xx1**2
        a2=0.5*xx0*xx1

           ug(jj,ip0,kk) = ug(jj,ip0,kk) + g1*a0
           ug(jj,ip1,kk) = ug(jj,ip1,kk) + g1*a1
           ug(jj,ip2,kk) = ug(jj,ip2,kk) + g1*a2
		   
		   else
		   
		    ip1 = nint((x-x0)*dxinv)
            ip0 = ip1 - 1
            ip2 = ip1 + 1

           xx1 = (x - float(ip1)*dx-x0)*dxinv
           xx0=xx1+1
           xx2=1-xx1

        ip1=mod(ip1+nx,nx) +1
        ip0=mod(ip0+nx,nx) +1
        ip2=mod(ip2+nx,nx) +1
c
c     center-Lambda2:
c
        a0=-0.5*xx1*xx2
        a1=1.-xx1**2
        a2=0.5*xx0*xx1

           ug(jj,ip0,kk) = ug(jj,ip0,kk) + g1*a0
           ug(jj,ip1,kk) = ug(jj,ip1,kk) + g1*a1
           ug(jj,ip2,kk) = ug(jj,ip2,kk) + g1*a2
		   
		   endif
	enddo

        RETURN
        END



