	subroutine x_advect(dt,np_bl)

c version pour GB
	
        include 'param.i'
        include 'param.h'
        include 'arrays.h'
        
		integer icfl(npg),itype(npg),itype_aux(npg),itag(npg)
		dimension xp_aux(npg),up_aux(npg),vx_aux(npg)

		
c	routine d'advection en x :
c	parcours des lignes horozontales
c	intilisation de particules
c	calcul des vitesses par RK2
c	tag des particules en focntion des varaitions de cfl
c	push and remesh

c	cfl=dt/dx utilisee pour calucls de blocs /corrections
	cfl=dt/dx

	npart=0
	ntag_total=0
	
	
c	 1) on balaie le tableau ug par lignes horizontales

	do k=1,nx
		zz=xmin+float(k-1)*dx
	do j=1,nx
		np=0
		yy=xmin+float(j-1)*dx
		do i=1,nx
c	initiliasation particules sur la ligne j,k
		if (abs(ug(i,j,k)).gt.circlim) then
		np=np+1
		up(np)=ug(i,j,k)
		xp(np)=xmin+float(i-1)*dx
                up_aux(np)=ug(i,j,k)
                xp_aux(np)=xmin+float(i-1)*dx
		endif
		enddo
c	 tag, push and remesh sur la ligne
		if (np.ne.0) then

c	evaluation des vitesse pour RK2

		call velox_x(np,j,k)
		do n=1,np
		xp0(n)=xp(n)
		xp(n)=xp(n)+0.5*dt*vx(n)
		if (xp(n).gt.xmax) xp(n)=xp(n)-xmax+xmin
		if (xp(n).lt.xmin) xp(n)=xp(n)+xmax-xmin
		enddo

c GB modif pour laversion avec correction: 
c  mettre en c les lignes qui suivent
c	et remplacer par call tag_particles
c	 modifs simlaires a faire dans y_advect et z_advect
	
		call velox_x(np,j,k)
cc		do n=1,np
cc	        xp_aux(n)=xp0(n)
cc	        vx_aux(n)=vx(n)
c	        itype(n)=1
c	        enddo

		call tag_particles(np,np_aux,ntag,np_bl,
	1   icfl,itype,itype_aux,itag,
	1	xp_aux,up_aux,vx_aux)
	
		if (ntag.ne.0) then
		do n=1,ntag
			ii=itag(n)
			xp(ii)=xp0(ii)+dt*vx(ii)
			if (xp(ii).gt.xmax) xp(ii)=xp(ii)-xmax+xmin
		enddo
		endif
			
222	continue
c GB: 	changer dans les lignes qui suivent np en np_aux :
		do n=1,np_aux
		xp_aux(n)=xp_aux(n)+dt*vx_aux(n)
	    if (xp_aux(n).gt.xmax) xp_aux(n)=xp_aux(n)-xmax+xmin
	    if (xp_aux(n).lt.xmin) xp_aux(n)=xp_aux(n)+xmax-xmin
		enddo
		jr=j
		kr=k
		call remeshx(np_aux,xp_aux,up_aux,itype,jr,kr)
c 
c GB : remesh des particules tagguees:
c appeler remeshx_tag et mettre pour les 2 derniers arguments
c	 les memes parametres que dans remeshx (remeshy ou remeshz si y_advect
c	 ou z_advect)
		if (ntag.ne.0) call remeshx_tag(ntag,itag,itype,icfl,jr,kr)
	
c	fin de ligne j,k:
	npart=npart+np
	ntag_total=ntag_total+ntag
		endif
	enddo
	enddo

	print*, 'NPART, NTAG ', npart,ntag_total
	return
	end
