	subroutine y_advect(dt,np_bl)
	
        include 'param.i'
        include 'param.h'
        
		integer icfl(npg),itype(npg),itype_aux(npg),itag(npg)
		dimension xp_aux(npg),up_aux(npg),vx_aux(npg)


		external velox

	      		
c	on balaie le lignes verticales

	do k=1,nx
		zz=xmin+float(k-1)*dx
	do i=1,nx
		np=0
		yy=xmin+float(i-1)*dx
		do j=1,nx
c	initiliasation particules sur la ligne j
		if (abs(ug(i,j,k)).gt.circlim) then
		np=np+1
		up_aux(np)=ug(i,j,k)
		xp_aux(np)=xmin+float(j-1)*dx
		endif
		enddo
c	 tag, push and remesh sur la ligne
		if (np.ne.0) then

c	evaluation des vitesse pour RK2

		do n=1,np
		xx=xp_aux(n)
		call velox_y(np,i,k)
		do n=1,np
		xp0(n)=xp(n)
		xp(n)=xp(n)+0.5*dt*vx(n)
		if (xp(n).gt.xmax) xp(n)=xp(n)-xmax+xmin
		if (xp(n).lt.xmin) xp(n)=xp(n)+xmax-xmin
		enddo
		call velox_y(np,i,k)
		do n=1,np
	        xp_aux(n)=xp0(n)
	        vx_aux(n)=vx(n)
	        itype(n)=1
	        enddo
			
222	continue
		do n=1,np
		xp_aux(n)=xp_aux(n)+dt*vx_aux(n)
	    if (xp_aux(n).gt.xmax) xp_aux(n)=xp_aux(n)-xmax+xmin
	    if (xp_aux(n).lt.xmin) xp_aux(n)=xp_aux(n)+xmax-xmin
		enddo
		ir=i
		kr=k
		call remeshy(np,xp_aux,up_aux,itype,ir,kr)
c	fin de ligne i :

		endif
	enddo
	enddo
	
	return
	end
