## @package parmepy.operator.monitors
# Parmes tools for data and fields monitoring.
#
# import and alias so that monitors are
# available with
# from parmepy.operators.monitors import Printer, ...
import printer
Printer = printer.Printer
import compute_forces
DragAndLift = compute_forces.DragAndLift
import reprojection_criterion
Reprojection_criterion = reprojection_criterion.Reprojection_criterion
import energy_enstrophy as energy_enstrophy
Energy_enstrophy = energy_enstrophy.Energy_enstrophy

# Set list for 'import *'
__all__ = ['DragAndLift', 'Energy_enstrophy',
           'Reprojection_criterion', 'Printer']

