module userMod

  implicit none
  
contains

  ! Already allocated pointer, no size information, intent(IN)
  subroutine modifyX(x,factor)
    
    real(kind=8), dimension(:),  intent(inout) :: x
    real(kind=8), intent(in) :: factor
    
    integer :: i
    do i=1,size(x)
       x(i) = i*factor
    end do
    
  end subroutine modifyX

  subroutine cas4(x)

    real(kind=8), dimension(:),  intent(inout) :: x


    print *, 'cas3a', x(1), ' ', x(2)

    x(2) = x(2) +1.65
    print *, 'cas 3b', x(1), ' ', x(2)

  end subroutine cas4

  subroutine cas5(x)

    !!   integer, intent(in) :: size
    real(kind=8), pointer, dimension(:) :: x

    allocate(x(2))
    x(1) =12
    x(2) = 8
    print *, 'cas5a', x(1), ' ', x(2)

    x(2) = 1.65
    print *, 'cas 5b', x(1), ' ', x(2)
    print * , x
  end subroutine cas5

  subroutine cas6(x)

    !!   integer, intent(in) :: size
    real(kind=8), pointer, dimension(:) :: x

    x(1) =12
    x(2) = 8
    print *, 'cas6a', shape(x), ' ', x(1), ' ', x(2)

    x(2) = 1.65
    print *, 'cas 6b', x(1), ' ', x(2)
    print * , x

  end subroutine cas6

  subroutine Application3()

  end subroutine Application3

end module userMod
